=== modified file 'NEWS'
--- NEWS	2010-03-10 06:38:27 +0000
+++ NEWS	2010-03-24 13:58:37 +0000
@@ -8,7 +8,6 @@
 bzr 2.2.0b1
 ###########
 
-:Codename: ???
 :2.2.0b1: Not released yet
 
 Compatibility Breaks
@@ -31,9 +30,20 @@
   ``bzrlib.tests.test_server``.
   (Vincent Ladeuil)
 
+* ``BranchReferenceFormat.initialize()`` now takes an optional name argument
+  as its second parameter, for consistency with the initialize() method of
+  other formats. (Jelmer Vernooij)
+
 New Features
 ************
 
+* Added ``bzr remove-branch`` command that can remove a local or remote 
+  branch. (Jelmer Vernooij, #276295)
+
+* ``bzr export`` now takes an optional argument ``--per-file-timestamps``
+  to set file mtimes to the last timestamp of the last revision in which
+  they were changed rather than the current time. (Jelmer Vernooij)
+
 * If the Apport crash-reporting tool is available, bzr crashes are now
   stored into the ``/var/crash`` apport spool directory, and the user is
   invited to report them to the developers from there, either
@@ -44,6 +54,21 @@
   treats backslash as an escape character on Windows.   (Gordon Tyler,
   #392248)
 
+* Plugins can be disabled by defining ``BZR_DISABLE_PLUGINS`` as
+  a list of plugin names separated by ':' (';' on windows).
+  (Vincent Ladeuil, #411413)
+
+* Plugins can be loaded from arbitrary locations by defining
+  ``BZR_PLUGINS_AT`` as a list of name@path separated by ':' (';' on
+  windows). This takes precedence over ``BZR_PLUGIN_PATH`` for the
+  specified plugins. This is targeted at plugin developers for punctual
+  needs and *not* intended to replace ``BZR_PLUGIN_PATH``.  
+  (Vincent Ladeuil, #82693)
+
+* Tag names can now be determined automatically by ``automatic_tag_name`` 
+  hooks on ``Branch`` if they are not specified on the command line.
+  (Jelmer Vernooij)
+
 * Tree-shape conflicts can be resolved by providing ``--take-this`` and
   ``--take-other`` to the ``bzr resolve`` command. Just marking the conflict
   as resolved is still accessible via the ``--done`` default action.
@@ -61,6 +86,11 @@
 * Allow exporting a single file using ``bzr export``.
   (Michal Junák, #511987)
 
+* Allow syscalls to automatically restart when ``TextUIFactory``'s
+  SIGWINCH handler is invoked, avoiding ``EINTR`` errors during blocking
+  IO, which are often poorly handled by Python's libraries and parts of
+  bzrlib.  (Andrew Bennetts, #496813)
+
 * Avoid infinite recursion when probing for apport.
   (Vincent Ladeuil, #516934)
 
@@ -70,12 +100,20 @@
 * ``bzr add`` will not add conflict related files unless explicitly required.
   (Vincent Ladeuil, #322767, #414589)
 
+* ``bzr dump-btree`` now works on ``*.cix`` and ``*.six`` files.  Those
+  indices do not have reference lists, so ``dump-btree`` will simply show
+  ``None`` instead.  (Andrew Bennetts, #488607)
+
 * ``bzr help`` will no longer trigger the get_missing_command hook when
   doing a topic lookup. This avoids prompting (like 'no command plugins/loom,
   did you mean log?') when getting help. In future we may trigger the hook 
   deliberately when no help topics match from any help index.
   (Robert Collins, #396261)
 
+* ``bzr log -n0 -r..A.B.C`` should not crash but just consider the None
+  revspec as representing the first revision of the branch.
+  (Vincent Ladeuil, #519862)
+
 * ``bzr remove-tree`` can now remove multiple working trees.
   (Jared Hance, Andrew Bennetts, #253137)
 
@@ -83,6 +121,10 @@
   the kept file on content conflicts where one side deleted the file.
   (Vincent Ladeuil, #529968)
 
+* ``bzr upgrade`` now creates the ``backup.bzr`` directory with the same
+  permissions as ``.bzr`` directory on a POSIX OS.
+  (Parth Malwankar, #262450)
+
 * ``bzr upgrade`` now names backup directory as ``backup.bzr.~N~`` instead
   of ``backup.bzr``. This directory is ignored by bzr commands such as
   ``add``.
@@ -92,6 +134,13 @@
   ftp servers while trying to take a lock.
   (Martin Pool, #528722)
 
+* DirStateRevisionTree.kind() was returning wrong result when 'kind'
+  changes occured between the workingtree and one of its parents.
+  (Vincent Ladeuil, #533437)
+
+* Fix stub sftp test server to call os.getcwdu().
+  (Vincent Ladeuil, #526211, #526353)
+
 * Network transfer amounts and rates are now displayed in SI units according
   to the Ubuntu Units Policy <https://wiki.ubuntu.com/UnitsPolicy>.
   (Gordon Tyler, #514399)
@@ -113,17 +162,44 @@
 * Tolerate patches with leading noise in ``bzr-handle-patch``.
   (Toshio Kuratomi, Martin Pool, #502076)
 
+* ``.bazaar``, ``.bazaar/bazaar.conf`` and ``.bzr.log`` inherit user and
+  group ownership from the containing directory. This allow bzr to work
+  better with sudo.
+  (Parth Malwankar, #376388)
+
 API Changes
 ***********
 
+* ``bzrlib.merge_directive._BaseMergeDirective`` has been renamed to 
+  ``bzrlib.merge_directive.BaseMergeDirective`` and is now public.
+  (Jelmer Vernooij)
+
+* ``BranchFormat.initialize`` now takes an optional ``name`` of the colocated 
+  branch to create. (Jelmer Vernooij)
+
+* ``BzrDir.get_branch_transport`` now takes an optional ``name`` of the 
+  colocated branch to open. (Jelmer Vernooij)
+
+* Added ``bzrlib.osutils.set_signal_handler``, a convenience function that
+  can set a signal handler and call ``signal.siginterrupt(signum,
+  False)`` for it, if the platform and Python version supports it.
+  (Andrew Bennetts, #496813)
+
 * New ``bzrlib.initialize`` is recommended for programs using bzrlib to 
   run when starting up; it sets up several things that previously needed
   to be done separately.
   (Martin Pool, #507710)
 
+* Exporters now support a ``per_file_timestamps`` argument to write out the 
+  timestamp of the commit in which a file revision was introduced.
+  (Jelmer Vernooij)
+
 * New method ``BzrDir.list_branches()`` that returns a sequence of branches 
   present in a control directory. (Jelmer Vernooij)
 
+* New transport methods ``readlink``, ``symlink`` and ``hardlink``.
+  (Neil Santos)
+
 * Remove unused ``CommandFailed`` exception.
   (Martin Pool)
 
@@ -146,6 +222,9 @@
 * ``bzrlib.errors.BoundBranchOutOfDate`` has a new field ``extra_help``
   which can be set to add extra help to the error. (Gary van der Merwe)
 
+* New method ``Branch.automatic_tag_name`` that can be used to find the
+  tag name for a particular revision automatically. (Jelmer Vernooij)
+
 * The methods ``BzrDir.create_branch()``, ``BzrDir.destroy_branch()`` and 
   ``BzrDir.open_branch()`` now take an optional ``name`` argument. 
   (Jelmer Vernooij)
@@ -183,6 +262,22 @@
 Bug Fixes
 *********
 
+* Allow syscalls to automatically restart when ``TextUIFactory``'s
+  SIGWINCH handler is invoked, avoiding ``EINTR`` errors during blocking
+  IO, which are often poorly handled by Python's libraries and parts of
+  bzrlib.  (Andrew Bennetts, #496813)
+
+* Avoid ``malloc(0)`` in ``patiencediff``, which is non-portable.
+  (Martin Pool, #331095)
+
+* Fix plugin packaging on Windows. (Ian Clatworthy, #524162)
+
+* Fix stub sftp test server to call os.getcwdu().
+  (Vincent Ladeuil, #526211, #526353)
+
+* Fixed CHM generation by moving the NEWS section template into
+  a separate file. (Ian Clatworthy, #524184)
+
 * Merge correctly when this_tree is not a WorkingTree.  (Aaron Bentley)
 
 * Register SIGWINCH handler only when creating a ``TextUIFactory``; avoids
@@ -207,6 +302,14 @@
 * Drop Google Analytics from the core docs as they caused problems
   in the CHM files. (Ian Clatworthy, #502010)
 
+API Changes
+***********
+
+* Added ``bzrlib.osutils.set_signal_handler``, a convenience function that
+  can set a signal handler and call ``signal.siginterrupt(signum,
+  False)`` for it, if the platform and Python version supports it.
+  (Andrew Bennetts, #496813)
+
 
 bzr 2.1.0
 #########
@@ -565,8 +668,8 @@
   (Martin Pool)
 
 
-bzr 2.0.5 (not released yet)
-############################
+bzr 2.0.5
+#########
 
 :Codename:
 :2.0.5: NOT RELEASED YET

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2010-02-23 07:43:11 +0000
+++ bzrlib/__init__.py	2010-03-24 21:10:33 +0000
@@ -47,7 +47,7 @@
 version_info = (2, 2, 0, 'dev', 1)
 
 # API compatibility version
-api_minimum_version = (2, 1, 0)
+api_minimum_version = (2, 2, 0)
 
 
 def _format_version_tuple(version_info):

=== modified file 'bzrlib/benchmarks/tree_creator/kernel_like.py'
--- bzrlib/benchmarks/tree_creator/kernel_like.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/tree_creator/kernel_like.py	2010-03-25 09:39:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -48,7 +48,8 @@
         if self._url is not None:
             b = bzrdir.BzrDir.create_branch_convenience(self._url)
             d = bzrdir.BzrDir.create(root)
-            bzrlib.branch.BranchReferenceFormat().initialize(d, b)
+            bzrlib.branch.BranchReferenceFormat().initialize(d,
+                target_branch=b)
             tree = d.create_workingtree()
         else:
             tree = bzrdir.BzrDir.create_standalone_workingtree(root)

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2010-03-02 19:50:18 +0000
+++ bzrlib/branch.py	2010-03-22 13:59:33 +0000
@@ -170,10 +170,10 @@
         return control.open_branch(unsupported=_unsupported)
 
     @staticmethod
-    def open_from_transport(transport, _unsupported=False):
+    def open_from_transport(transport, name=None, _unsupported=False):
         """Open the branch rooted at transport"""
         control = bzrdir.BzrDir.open_from_transport(transport, _unsupported)
-        return control.open_branch(unsupported=_unsupported)
+        return control.open_branch(name=name, unsupported=_unsupported)
 
     @staticmethod
     def open_containing(url, possible_transports=None):
@@ -217,9 +217,9 @@
     def _get_fallback_repository(self, url):
         """Get the repository we fallback to at url."""
         url = urlutils.join(self.base, url)
-        a_bzrdir = bzrdir.BzrDir.open(url,
+        a_branch = Branch.open(url,
             possible_transports=[self.bzrdir.root_transport])
-        return a_bzrdir.open_branch().repository
+        return a_branch.repository
 
     def _get_tags_bytes(self):
         """Get the bytes of a serialised tags dict.
@@ -1317,7 +1317,8 @@
         if lightweight:
             format = self._get_checkout_format()
             checkout = format.initialize_on_transport(t)
-            from_branch = BranchReferenceFormat().initialize(checkout, self)
+            from_branch = BranchReferenceFormat().initialize(checkout, 
+                target_branch=self)
         else:
             format = self._get_checkout_format()
             checkout_branch = bzrdir.BzrDir.create_branch_convenience(
@@ -1365,6 +1366,18 @@
     def supports_tags(self):
         return self._format.supports_tags()
 
+    def automatic_tag_name(self, revision_id):
+        """Try to automatically find the tag name for a revision.
+
+        :param revision_id: Revision id of the revision.
+        :return: A tag name or None if no tag name could be determined.
+        """
+        for hook in Branch.hooks['automatic_tag_name']:
+            ret = hook(self, revision_id)
+            if ret is not None:
+                return ret
+        return None
+
     def _check_if_descendant_or_diverged(self, revision_a, revision_b, graph,
                                          other_branch):
         """Ensure that revision_b is a descendant of revision_a.
@@ -1434,10 +1447,10 @@
         return not (self == other)
 
     @classmethod
-    def find_format(klass, a_bzrdir):
+    def find_format(klass, a_bzrdir, name=None):
         """Return the format for the branch object in a_bzrdir."""
         try:
-            transport = a_bzrdir.get_branch_transport(None)
+            transport = a_bzrdir.get_branch_transport(None, name=name)
             format_string = transport.get_bytes("format")
             return klass._formats[format_string]
         except errors.NoSuchFile:
@@ -1483,20 +1496,21 @@
         """Return the short format description for this format."""
         raise NotImplementedError(self.get_format_description)
 
-    def _initialize_helper(self, a_bzrdir, utf8_files, lock_type='metadir',
-                           set_format=True):
+    def _initialize_helper(self, a_bzrdir, utf8_files, name=None,
+                           lock_type='metadir', set_format=True):
         """Initialize a branch in a bzrdir, with specified files
 
         :param a_bzrdir: The bzrdir to initialize the branch in
         :param utf8_files: The files to create as a list of
             (filename, content) tuples
+        :param name: Name of colocated branch to create, if any
         :param set_format: If True, set the format with
             self.get_format_string.  (BzrBranch4 has its format set
             elsewhere)
         :return: a branch in this format
         """
         mutter('creating branch %r in %s', self, a_bzrdir.transport.base)
-        branch_transport = a_bzrdir.get_branch_transport(self)
+        branch_transport = a_bzrdir.get_branch_transport(self, name=name)
         lock_map = {
             'metadir': ('lock', lockdir.LockDir),
             'branch4': ('branch-lock', lockable_files.TransportLock),
@@ -1523,10 +1537,13 @@
         finally:
             if lock_taken:
                 control_files.unlock()
-        return self.open(a_bzrdir, _found=True)
+        return self.open(a_bzrdir, name, _found=True)
 
-    def initialize(self, a_bzrdir):
-        """Create a branch of this format in a_bzrdir."""
+    def initialize(self, a_bzrdir, name=None):
+        """Create a branch of this format in a_bzrdir.
+        
+        :param name: Name of the colocated branch to create.
+        """
         raise NotImplementedError(self.initialize)
 
     def is_supported(self):
@@ -1562,10 +1579,11 @@
         """
         raise NotImplementedError(self.network_name)
 
-    def open(self, a_bzrdir, _found=False, ignore_fallbacks=False):
+    def open(self, a_bzrdir, name=None, _found=False, ignore_fallbacks=False):
         """Return the branch object for a_bzrdir
 
         :param a_bzrdir: A BzrDir that contains a branch.
+        :param name: Name of colocated branch to open
         :param _found: a private parameter, do not use it. It is used to
             indicate if format probing has already be done.
         :param ignore_fallbacks: when set, no fallback branches will be opened
@@ -1679,6 +1697,13 @@
             "multiple hooks installed for transform_fallback_location, "
             "all are called with the url returned from the previous hook."
             "The order is however undefined.", (1, 9), None))
+        self.create_hook(HookPoint('automatic_tag_name',
+            "Called to determine an automatic tag name for a revision."
+            "automatic_tag_name is called with (branch, revision_id) and "
+            "should return a tag name or None if no tag name could be "
+            "determined. The first non-None tag name returned will be used.",
+            (2, 2), None))
+
 
 
 # install the default hooks into the Branch class.
@@ -1735,12 +1760,12 @@
         """See BranchFormat.get_format_description()."""
         return "Branch format 4"
 
-    def initialize(self, a_bzrdir):
+    def initialize(self, a_bzrdir, name=None):
         """Create a branch of this format in a_bzrdir."""
         utf8_files = [('revision-history', ''),
                       ('branch-name', ''),
                       ]
-        return self._initialize_helper(a_bzrdir, utf8_files,
+        return self._initialize_helper(a_bzrdir, utf8_files, name=name,
                                        lock_type='branch4', set_format=False)
 
     def __init__(self):
@@ -1751,7 +1776,7 @@
         """The network name for this format is the control dirs disk label."""
         return self._matchingbzrdir.get_format_string()
 
-    def open(self, a_bzrdir, _found=False, ignore_fallbacks=False):
+    def open(self, a_bzrdir, name=None, _found=False, ignore_fallbacks=False):
         """See BranchFormat.open()."""
         if not _found:
             # we are being called directly and must probe.
@@ -1759,6 +1784,7 @@
         return BzrBranch(_format=self,
                          _control_files=a_bzrdir._control_files,
                          a_bzrdir=a_bzrdir,
+                         name=name,
                          _repository=a_bzrdir.open_repository())
 
     def __str__(self):
@@ -1779,19 +1805,20 @@
         """
         return self.get_format_string()
 
-    def open(self, a_bzrdir, _found=False, ignore_fallbacks=False):
+    def open(self, a_bzrdir, name=None, _found=False, ignore_fallbacks=False):
         """See BranchFormat.open()."""
         if not _found:
-            format = BranchFormat.find_format(a_bzrdir)
+            format = BranchFormat.find_format(a_bzrdir, name=name)
             if format.__class__ != self.__class__:
                 raise AssertionError("wrong format %r found for %r" %
                     (format, self))
         try:
-            transport = a_bzrdir.get_branch_transport(None)
+            transport = a_bzrdir.get_branch_transport(None, name=name)
             control_files = lockable_files.LockableFiles(transport, 'lock',
                                                          lockdir.LockDir)
             return self._branch_class()(_format=self,
                               _control_files=control_files,
+                              name=name,
                               a_bzrdir=a_bzrdir,
                               _repository=a_bzrdir.find_repository(),
                               ignore_fallbacks=ignore_fallbacks)
@@ -1831,12 +1858,12 @@
         """See BranchFormat.get_format_description()."""
         return "Branch format 5"
 
-    def initialize(self, a_bzrdir):
+    def initialize(self, a_bzrdir, name=None):
         """Create a branch of this format in a_bzrdir."""
         utf8_files = [('revision-history', ''),
                       ('branch-name', ''),
                       ]
-        return self._initialize_helper(a_bzrdir, utf8_files)
+        return self._initialize_helper(a_bzrdir, utf8_files, name)
 
     def supports_tags(self):
         return False
@@ -1864,13 +1891,13 @@
         """See BranchFormat.get_format_description()."""
         return "Branch format 6"
 
-    def initialize(self, a_bzrdir):
+    def initialize(self, a_bzrdir, name=None):
         """Create a branch of this format in a_bzrdir."""
         utf8_files = [('last-revision', '0 null:\n'),
                       ('branch.conf', ''),
                       ('tags', ''),
                       ]
-        return self._initialize_helper(a_bzrdir, utf8_files)
+        return self._initialize_helper(a_bzrdir, utf8_files, name)
 
     def make_tags(self, branch):
         """See bzrlib.branch.BranchFormat.make_tags()."""
@@ -1894,14 +1921,14 @@
         """See BranchFormat.get_format_description()."""
         return "Branch format 8"
 
-    def initialize(self, a_bzrdir):
+    def initialize(self, a_bzrdir, name=None):
         """Create a branch of this format in a_bzrdir."""
         utf8_files = [('last-revision', '0 null:\n'),
                       ('branch.conf', ''),
                       ('tags', ''),
                       ('references', '')
                       ]
-        return self._initialize_helper(a_bzrdir, utf8_files)
+        return self._initialize_helper(a_bzrdir, utf8_files, name)
 
     def __init__(self):
         super(BzrBranchFormat8, self).__init__()
@@ -1930,13 +1957,13 @@
     This format was introduced in bzr 1.6.
     """
 
-    def initialize(self, a_bzrdir):
+    def initialize(self, a_bzrdir, name=None):
         """Create a branch of this format in a_bzrdir."""
         utf8_files = [('last-revision', '0 null:\n'),
                       ('branch.conf', ''),
                       ('tags', ''),
                       ]
-        return self._initialize_helper(a_bzrdir, utf8_files)
+        return self._initialize_helper(a_bzrdir, utf8_files, name)
 
     def _branch_class(self):
         return BzrBranch7
@@ -1984,19 +2011,19 @@
         transport = a_bzrdir.get_branch_transport(None)
         location = transport.put_bytes('location', to_branch.base)
 
-    def initialize(self, a_bzrdir, target_branch=None):
+    def initialize(self, a_bzrdir, name=None, target_branch=None):
         """Create a branch of this format in a_bzrdir."""
         if target_branch is None:
             # this format does not implement branch itself, thus the implicit
             # creation contract must see it as uninitializable
             raise errors.UninitializableFormat(self)
         mutter('creating branch reference in %s', a_bzrdir.transport.base)
-        branch_transport = a_bzrdir.get_branch_transport(self)
+        branch_transport = a_bzrdir.get_branch_transport(self, name=name)
         branch_transport.put_bytes('location',
             target_branch.bzrdir.root_transport.base)
         branch_transport.put_bytes('format', self.get_format_string())
         return self.open(
-            a_bzrdir, _found=True,
+            a_bzrdir, name, _found=True,
             possible_transports=[target_branch.bzrdir.root_transport])
 
     def __init__(self):
@@ -2009,17 +2036,18 @@
         def clone(to_bzrdir, revision_id=None,
             repository_policy=None):
             """See Branch.clone()."""
-            return format.initialize(to_bzrdir, a_branch)
+            return format.initialize(to_bzrdir, target_branch=a_branch)
             # cannot obey revision_id limits when cloning a reference ...
             # FIXME RBC 20060210 either nuke revision_id for clone, or
             # emit some sort of warning/error to the caller ?!
         return clone
 
-    def open(self, a_bzrdir, _found=False, location=None,
+    def open(self, a_bzrdir, name=None, _found=False, location=None,
              possible_transports=None, ignore_fallbacks=False):
         """Return the branch that the branch reference in a_bzrdir points at.
 
         :param a_bzrdir: A BzrDir that contains a branch.
+        :param name: Name of colocated branch to open, if any
         :param _found: a private parameter, do not use it. It is used to
             indicate if format probing has already be done.
         :param ignore_fallbacks: when set, no fallback branches will be opened
@@ -2030,7 +2058,7 @@
         :param possible_transports: An optional reusable transports list.
         """
         if not _found:
-            format = BranchFormat.find_format(a_bzrdir)
+            format = BranchFormat.find_format(a_bzrdir, name=name)
             if format.__class__ != self.__class__:
                 raise AssertionError("wrong format %r found for %r" %
                     (format, self))
@@ -2038,7 +2066,8 @@
             location = self.get_reference(a_bzrdir)
         real_bzrdir = bzrdir.BzrDir.open(
             location, possible_transports=possible_transports)
-        result = real_bzrdir.open_branch(ignore_fallbacks=ignore_fallbacks)
+        result = real_bzrdir.open_branch(name=name, 
+            ignore_fallbacks=ignore_fallbacks)
         # this changes the behaviour of result.clone to create a new reference
         # rather than a copy of the content of the branch.
         # I did not use a proxy object because that needs much more extensive
@@ -2090,17 +2119,20 @@
     :ivar repository: Repository for this branch.
     :ivar base: The url of the base directory for this branch; the one
         containing the .bzr directory.
+    :ivar name: Optional colocated branch name as it exists in the control
+        directory.
     """
 
     def __init__(self, _format=None,
-                 _control_files=None, a_bzrdir=None, _repository=None,
-                 ignore_fallbacks=False):
+                 _control_files=None, a_bzrdir=None, name=None,
+                 _repository=None, ignore_fallbacks=False):
         """Create new branch object at a particular location."""
         if a_bzrdir is None:
             raise ValueError('a_bzrdir must be supplied')
         else:
             self.bzrdir = a_bzrdir
         self._base = self.bzrdir.transport.clone('..').base
+        self.name = name
         # XXX: We should be able to just do
         #   self.base = self.bzrdir.root_transport.base
         # but this does not quite work yet -- mbp 20080522
@@ -2113,7 +2145,10 @@
         Branch.__init__(self)
 
     def __str__(self):
-        return '%s(%r)' % (self.__class__.__name__, self.base)
+        if self.name is None:
+            return '%s(%r)' % (self.__class__.__name__, self.base)
+        else:
+            return '%s(%r,%r)' % (self.__class__.__name__, self.base, self.name)
 
     __repr__ = __str__
 

=== modified file 'bzrlib/btree_index.py'
--- bzrlib/btree_index.py	2010-02-17 17:11:16 +0000
+++ bzrlib/btree_index.py	2010-03-13 23:13:48 +0000
@@ -567,7 +567,7 @@
                     else:
                         # yield keys
                         for value in key_dict.itervalues():
-                            yield (self, ) + value
+                            yield (self, ) + tuple(value)
             else:
                 yield (self, ) + key_dict
 

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2010-03-03 08:25:15 +0000
+++ bzrlib/builtins.py	2010-03-25 06:52:38 +0000
@@ -456,7 +456,12 @@
         for node in bt.iter_all_entries():
             # Node is made up of:
             # (index, key, value, [references])
-            refs_as_tuples = static_tuple.as_tuples(node[3])
+            try:
+                refs = node[3]
+            except IndexError:
+                refs_as_tuples = None
+            else:
+                refs_as_tuples = static_tuple.as_tuples(refs)
             as_tuple = (tuple(node[1]), node[2], refs_as_tuples)
             self.outf.write('%s\n' % (as_tuple,))
 
@@ -2433,7 +2438,11 @@
             raise errors.BzrCommandError(
                 "bzr %s doesn't accept two revisions in different"
                 " branches." % command_name)
-        rev1 = start_spec.in_history(branch)
+        if start_spec.spec is None:
+            # Avoid loading all the history.
+            rev1 = RevisionInfo(branch, None, None)
+        else:
+            rev1 = start_spec.in_history(branch)
         # Avoid loading all of history when we know a missing
         # end of range means the last revision ...
         if end_spec.spec is None:
@@ -2806,9 +2815,12 @@
         Option('root',
                type=str,
                help="Name of the root directory inside the exported file."),
+        Option('per-file-timestamps',
+               help='Set modification time of files to that of the last '
+                    'revision in which it was changed.'),
         ]
     def run(self, dest, branch_or_subdir=None, revision=None, format=None,
-        root=None, filters=False):
+        root=None, filters=False, per_file_timestamps=False):
         from bzrlib.export import export
 
         if branch_or_subdir is None:
@@ -2821,7 +2833,8 @@
 
         rev_tree = _get_one_revision_tree('export', revision, branch=b, tree=tree)
         try:
-            export(rev_tree, dest, format, root, subdir, filtered=filters)
+            export(rev_tree, dest, format, root, subdir, filtered=filters,
+                   per_file_timestamps=per_file_timestamps)
         except errors.NoSuchExportFormat, e:
             raise errors.BzrCommandError('Unsupported export format: %s' % e.format)
 
@@ -5139,7 +5152,7 @@
                short_name='f',
                type=unicode),
         Option('output', short_name='o',
-               help='Write merge directive to this file; '
+               help='Write merge directive to this file or directory; '
                     'use - for stdout.',
                type=unicode),
         Option('strict',
@@ -5255,10 +5268,15 @@
 
     To rename a tag (change the name but keep it on the same revsion), run ``bzr
     tag new-name -r tag:old-name`` and then ``bzr tag --delete oldname``.
+
+    If no tag name is specified it will be determined through the 
+    'automatic_tag_name' hook. This can e.g. be used to automatically tag
+    upstream releases by reading configure.ac. See ``bzr help hooks`` for
+    details.
     """
 
     _see_also = ['commit', 'tags']
-    takes_args = ['tag_name']
+    takes_args = ['tag_name?']
     takes_options = [
         Option('delete',
             help='Delete this tag rather than placing it.',
@@ -5274,7 +5292,7 @@
         'revision',
         ]
 
-    def run(self, tag_name,
+    def run(self, tag_name=None,
             delete=None,
             directory='.',
             force=None,
@@ -5284,6 +5302,8 @@
         branch.lock_write()
         self.add_cleanup(branch.unlock)
         if delete:
+            if tag_name is None:
+                raise errors.BzrCommandError("No tag specified to delete.")
             branch.tags.delete_tag(tag_name)
             self.outf.write('Deleted tag %s.\n' % tag_name)
         else:
@@ -5295,6 +5315,11 @@
                 revision_id = revision[0].as_revision_id(branch)
             else:
                 revision_id = branch.last_revision()
+            if tag_name is None:
+                tag_name = branch.automatic_tag_name(revision_id)
+                if tag_name is None:
+                    raise errors.BzrCommandError(
+                        "Please specify a tag name.")
             if (not force) and branch.tags.has_tag(tag_name):
                 raise errors.TagAlreadyExists(tag_name)
             branch.tags.set_tag(tag_name, revision_id)
@@ -5736,6 +5761,31 @@
                     self.outf.write("    <no hooks installed>\n")
 
 
+class cmd_remove_branch(Command):
+    """Remove a branch.
+
+    This will remove the branch from the specified location but 
+    will keep any working tree or repository in place.
+
+    :Examples:
+
+      Remove the branch at repo/trunk::
+
+        bzr remove-branch repo/trunk
+
+    """
+
+    takes_args = ["location?"]
+
+    aliases = ["rmbranch"]
+
+    def run(self, location=None):
+        if location is None:
+            location = "."
+        branch = Branch.open_containing(location)[0]
+        branch.bzrdir.destroy_branch()
+        
+
 class cmd_shelve(Command):
     """Temporarily set aside some changes from the current tree.
 
@@ -5924,15 +5974,7 @@
             self.outf.write('%s %s\n' % (path, location))
 
 
-# these get imported and then picked up by the scan for cmd_*
-# TODO: Some more consistent way to split command definitions across files;
-# we do need to load at least some information about them to know of
-# aliases.  ideally we would avoid loading the implementation until the
-# details were needed.
 from bzrlib.cmd_version_info import cmd_version_info
 from bzrlib.conflicts import cmd_resolve, cmd_conflicts, restore
-from bzrlib.bundle.commands import (
-    cmd_bundle_info,
-    )
 from bzrlib.foreign import cmd_dpush
 from bzrlib.sign_my_commits import cmd_sign_my_commits

=== modified file 'bzrlib/bundle/commands.py'
--- bzrlib/bundle/commands.py	2009-03-23 14:59:43 +0000
+++ bzrlib/bundle/commands.py	2010-03-25 09:39:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -54,7 +54,7 @@
         from bzrlib import osutils
         term_encoding = osutils.get_terminal_encoding()
         bundle_info = read_mergeable_from_url(location)
-        if isinstance(bundle_info, merge_directive._BaseMergeDirective):
+        if isinstance(bundle_info, merge_directive.BaseMergeDirective):
             bundle_file = StringIO(bundle_info.get_raw_bundle())
             bundle_info = read_bundle(bundle_file)
         else:

=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2010-03-05 23:17:03 +0000
+++ bzrlib/bzrdir.py	2010-03-17 05:36:11 +0000
@@ -602,8 +602,6 @@
             # already exists, but it should instead either remove it or make
             # a new backup directory.
             #
-            # FIXME: bug 262450 -- the backup directory should have the same
-            # permissions as the .bzr directory (probably a bug in copy_tree)
             old_path = self.root_transport.abspath('.bzr')
             new_path = self.root_transport.abspath(backup_dir)
             ui.ui_factory.note('making backup of %s\n  to %s' % (old_path, new_path,))
@@ -715,7 +713,7 @@
         """
         return None
 
-    def get_branch_transport(self, branch_format):
+    def get_branch_transport(self, branch_format, name=None):
         """Get the transport for use by branch format in this BzrDir.
 
         Note that bzr dirs that do not support format strings will raise
@@ -1383,9 +1381,7 @@
 
     def create_branch(self, name=None):
         """See BzrDir.create_branch."""
-        if name is not None:
-            raise errors.NoColocatedBranchSupport(self)
-        return self._format.get_branch_format().initialize(self)
+        return self._format.get_branch_format().initialize(self, name=name)
 
     def destroy_branch(self, name=None):
         """See BzrDir.destroy_branch."""
@@ -1449,8 +1445,10 @@
         raise errors.UnsupportedOperation(self.destroy_workingtree_metadata,
                                           self)
 
-    def get_branch_transport(self, branch_format):
+    def get_branch_transport(self, branch_format, name=None):
         """See BzrDir.get_branch_transport()."""
+        if name is not None:
+            raise errors.NoColocatedBranchSupport(self)
         if branch_format is None:
             return self.transport
         try:
@@ -1492,12 +1490,10 @@
     def open_branch(self, name=None, unsupported=False,
                     ignore_fallbacks=False):
         """See BzrDir.open_branch."""
-        if name is not None:
-            raise errors.NoColocatedBranchSupport(self)
         from bzrlib.branch import BzrBranchFormat4
         format = BzrBranchFormat4()
         self._check_supported(format, unsupported)
-        return format.open(self, _found=True)
+        return format.open(self, name, _found=True)
 
     def sprout(self, url, revision_id=None, force_new_repo=False,
                possible_transports=None, accelerator_tree=None,
@@ -1622,9 +1618,7 @@
 
     def create_branch(self, name=None):
         """See BzrDir.create_branch."""
-        if name is not None:
-            raise errors.NoColocatedBranchSupport(self)
-        return self._format.get_branch_format().initialize(self)
+        return self._format.get_branch_format().initialize(self, name=name)
 
     def destroy_branch(self, name=None):
         """See BzrDir.create_branch."""
@@ -1678,8 +1672,10 @@
         format = BranchFormat.find_format(self)
         return format.get_reference(self)
 
-    def get_branch_transport(self, branch_format):
+    def get_branch_transport(self, branch_format, name=None):
         """See BzrDir.get_branch_transport()."""
+        if name is not None:
+            raise errors.NoColocatedBranchSupport(self)
         # XXX: this shouldn't implicitly create the directory if it's just
         # promising to get a transport -- mbp 20090727
         if branch_format is None:
@@ -1774,11 +1770,10 @@
     def open_branch(self, name=None, unsupported=False,
                     ignore_fallbacks=False):
         """See BzrDir.open_branch."""
-        if name is not None:
-            raise errors.NoColocatedBranchSupport(self)
         format = self.find_branch_format()
         self._check_supported(format, unsupported)
-        return format.open(self, _found=True, ignore_fallbacks=ignore_fallbacks)
+        return format.open(self, name=name,
+            _found=True, ignore_fallbacks=ignore_fallbacks)
 
     def open_repository(self, unsupported=False):
         """See BzrDir.open_repository."""

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2010-03-01 09:27:39 +0000
+++ bzrlib/commands.py	2010-03-25 06:52:38 +0000
@@ -15,9 +15,6 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 
-# TODO: probably should say which arguments are candidates for glob
-# expansion on windows and do that at the command level.
-
 # TODO: Define arguments by objects, rather than just using names.
 # Those objects can specify the expected type of the argument, which
 # would help with validation and shell completion.  They could also provide
@@ -25,9 +22,6 @@
 
 # TODO: Specific "examples" property on commands for consistent formatting.
 
-# TODO: "--profile=cum", to change sort order.  Is there any value in leaving
-# the profile output behind so it can be interactively examined?
-
 import os
 import sys
 
@@ -78,6 +72,22 @@
 
 
 class CommandRegistry(registry.Registry):
+    """Special registry mapping command names to command classes.
+    
+    :ivar overridden_registry: Look in this registry for commands being
+        overridden by this registry.  This can be used to tell plugin commands
+        about the builtin they're decorating.
+    """
+
+    def __init__(self):
+        registry.Registry.__init__(self)
+        self.overridden_registry = None
+        # map from aliases to the real command that implements the name
+        self._alias_dict = {}
+
+    def get(self, command_name):
+        real_name = self._alias_dict.get(command_name, command_name)
+        return registry.Registry.get(self, real_name)
 
     @staticmethod
     def _get_name(command_name):
@@ -99,7 +109,12 @@
         try:
             previous = self.get(k_unsquished)
         except KeyError:
-            previous = _builtin_commands().get(k_unsquished)
+            previous = None
+            if self.overridden_registry:
+                try:
+                    previous = self.overridden_registry.get(k_unsquished)
+                except KeyError:
+                    pass
         info = CommandInfo.from_command(cmd)
         try:
             registry.Registry.register(self, k_unsquished, cmd,
@@ -110,6 +125,8 @@
                 sys.modules[cmd.__module__])
             trace.warning('Previously this command was registered from %r' %
                 sys.modules[previous.__module__])
+        for a in cmd.aliases:
+            self._alias_dict[a] = k_unsquished
         return previous
 
     def register_lazy(self, command_name, aliases, module_name):
@@ -122,12 +139,20 @@
         key = self._get_name(command_name)
         registry.Registry.register_lazy(self, key, module_name, command_name,
                                         info=CommandInfo(aliases))
+        for a in aliases:
+            self._alias_dict[a] = key
 
 
 plugin_cmds = CommandRegistry()
+builtin_command_registry = CommandRegistry()
+plugin_cmds.overridden_registry = builtin_command_registry
 
 
 def register_command(cmd, decorate=False):
+    """Register a plugin command.
+
+    Should generally be avoided in favor of lazy registration. 
+    """
     global plugin_cmds
     return plugin_cmds.register(cmd, decorate)
 
@@ -140,9 +165,27 @@
     return cmd[4:].replace('_','-')
 
 
+@deprecated_function(deprecated_in((2, 2, 0)))
 def _builtin_commands():
+    """Return a dict of {name: cmd_class} for builtin commands.
+
+    :deprecated: Use the builtin_command_registry registry instead
+    """
+    # return dict(name: cmd_class)
+    return dict(builtin_command_registry.items())
+
+
+def _register_builtin_commands():
+    if builtin_command_registry.keys():
+        # only load once
+        return
     import bzrlib.builtins
-    return _scan_module_for_commands(bzrlib.builtins)
+    for cmd_class in _scan_module_for_commands(bzrlib.builtins).values():
+        builtin_command_registry.register(cmd_class)
+    # lazy builtins
+    builtin_command_registry.register_lazy('cmd_bundle_info',
+        [],
+        'bzrlib.bundle.commands')
 
 
 def _scan_module_for_commands(module):
@@ -155,7 +198,10 @@
 
 
 def _list_bzr_commands(names):
-    """Find commands from bzr's core and plugins."""
+    """Find commands from bzr's core and plugins.
+    
+    This is not the public interface, just the default hook called by all_command_names.
+    """
     # to eliminate duplicates
     names.update(builtin_command_names())
     names.update(plugin_command_names())
@@ -179,7 +225,7 @@
     Use of all_command_names() is encouraged rather than builtin_command_names
     and/or plugin_command_names.
     """
-    return _builtin_commands().keys()
+    return builtin_command_registry.keys()
 
 
 def plugin_command_names():
@@ -263,15 +309,12 @@
 
 def _get_bzr_command(cmd_or_None, cmd_name):
     """Get a command from bzr's core."""
-    cmds = _builtin_commands()
     try:
-        return cmds[cmd_name]()
+        cmd_class = builtin_command_registry.get(cmd_name)
     except KeyError:
         pass
-    # look for any command which claims this as an alias
-    for real_cmd_name, cmd_class in cmds.iteritems():
-        if cmd_name in cmd_class.aliases:
-            return cmd_class()
+    else:
+        return cmd_class()
     return cmd_or_None
 
 
@@ -1116,6 +1159,7 @@
     :return: exit code of bzr command.
     """
     argv = _specified_or_unicode_argv(argv)
+    _register_builtin_commands()
     ret = run_bzr_catch_errors(argv)
     bzrlib.ui.ui_factory.log_transport_activity(
         display=('bytes' in debug.debug_flags))

=== modified file 'bzrlib/config.py'
--- bzrlib/config.py	2010-02-23 07:43:11 +0000
+++ bzrlib/config.py	2010-03-06 05:28:17 +0000
@@ -510,7 +510,8 @@
         self._write_config_file()
 
     def _write_config_file(self):
-        f = open(self._get_filename(), 'wb')
+        path = self._get_filename()
+        f = osutils.open_with_ownership(path, 'wb')
         self._get_parser().write(f)
         f.close()
 
@@ -809,7 +810,7 @@
                 trace.mutter('creating config parent directory: %r', parent_dir)
             os.mkdir(parent_dir)
         trace.mutter('creating config directory: %r', path)
-        os.mkdir(path)
+        osutils.mkdir_with_ownership(path)
 
 
 def config_dir():

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2010-03-03 08:25:15 +0000
+++ bzrlib/errors.py	2010-03-24 14:15:01 +0000
@@ -1179,7 +1179,7 @@
 
 class InvalidRevisionSpec(BzrError):
 
-    _fmt = ("Requested revision: %(spec)r does not exist in branch:"
+    _fmt = ("Requested revision: '%(spec)s' does not exist in branch:"
             " %(branch)s%(extra)s")
 
     def __init__(self, spec, branch, extra=None):

=== modified file 'bzrlib/export/__init__.py'
--- bzrlib/export/__init__.py	2010-01-29 12:04:38 +0000
+++ bzrlib/export/__init__.py	2010-03-25 09:39:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,7 +19,6 @@
 Such as non-controlled directories, tarfiles, zipfiles, etc.
 """
 
-from bzrlib.trace import mutter
 import os
 import bzrlib.errors as errors
 
@@ -55,14 +54,16 @@
 
     When requesting a specific type of export, load the respective path.
     """
-    def _loader(tree, dest, root, subdir, filtered):
+    def _loader(tree, dest, root, subdir, filtered, per_file_timestamps):
         mod = __import__(module, globals(), locals(), [funcname])
         func = getattr(mod, funcname)
-        return func(tree, dest, root, subdir, filtered=filtered)
+        return func(tree, dest, root, subdir, filtered=filtered,
+                    per_file_timestamps=per_file_timestamps)
     register_exporter(scheme, extensions, _loader)
 
 
-def export(tree, dest, format=None, root=None, subdir=None, filtered=False):
+def export(tree, dest, format=None, root=None, subdir=None, filtered=False,
+           per_file_timestamps=False):
     """Export the given Tree to the specific destination.
 
     :param tree: A Tree (such as RevisionTree) to export
@@ -81,6 +82,9 @@
         a directory to start exporting from.
     :param filtered: If True, content filtering is applied to the
                      files exported.
+    :param per_file_timestamps: Whether to use the timestamp stored in the 
+        tree rather than now(). This will do a revision lookup 
+        for every file so will be significantly slower.
     """
     global _exporters, _exporter_extensions
 
@@ -99,7 +103,8 @@
         raise errors.NoSuchExportFormat(format)
     tree.lock_read()
     try:
-        return _exporters[format](tree, dest, root, subdir, filtered=filtered)
+        return _exporters[format](tree, dest, root, subdir, filtered=filtered,
+                                  per_file_timestamps=per_file_timestamps)
     finally:
         tree.unlock()
 

=== modified file 'bzrlib/export/dir_exporter.py'
--- bzrlib/export/dir_exporter.py	2010-02-23 07:43:11 +0000
+++ bzrlib/export/dir_exporter.py	2010-03-08 02:23:17 +0000
@@ -18,7 +18,6 @@
 
 import errno
 import os
-import StringIO
 import time
 
 from bzrlib import errors, osutils
@@ -30,7 +29,8 @@
 from bzrlib.trace import mutter
 
 
-def dir_exporter(tree, dest, root, subdir, filtered=False):
+def dir_exporter(tree, dest, root, subdir, filtered=False,
+                 per_file_timestamps=False):
     """Export this tree to a new directory.
 
     `dest` should either not exist or should be empty. If it does not exist it
@@ -92,4 +92,8 @@
             out.writelines(chunks)
         finally:
             out.close()
-        os.utime(fullpath, (now, now))
+        if per_file_timestamps:
+            mtime = tree.get_file_mtime(tree.path2id(relpath), relpath)
+        else:
+            mtime = now
+        os.utime(fullpath, (mtime, mtime))

=== modified file 'bzrlib/export/tar_exporter.py'
--- bzrlib/export/tar_exporter.py	2009-03-23 14:59:43 +0000
+++ bzrlib/export/tar_exporter.py	2010-03-25 09:39:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008 Canonical Ltd
+# Copyright (C) 2005, 2006, 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,13 +17,12 @@
 """Export a Tree to a non-versioned directory.
 """
 
-import os
 import StringIO
 import sys
 import tarfile
 import time
 
-from bzrlib import errors, export, osutils
+from bzrlib import export, osutils
 from bzrlib.export import _export_iter_entries
 from bzrlib.filters import (
     ContentFilterContext,
@@ -32,7 +31,8 @@
 from bzrlib.trace import mutter
 
 
-def tar_exporter(tree, dest, root, subdir, compression=None, filtered=False):
+def tar_exporter(tree, dest, root, subdir, compression=None, filtered=False,
+                 per_file_timestamps=False):
     """Export this tree to a new tar file.
 
     `dest` will be created holding the contents of this tree; if it
@@ -52,7 +52,10 @@
     for dp, ie in _export_iter_entries(tree, subdir):
         filename = osutils.pathjoin(root, dp).encode('utf8')
         item = tarfile.TarInfo(filename)
-        item.mtime = now
+        if per_file_timestamps:
+            item.mtime = tree.get_file_mtime(ie.file_id, dp)
+        else:
+            item.mtime = now
         if ie.kind == "file":
             item.type = tarfile.REGTYPE
             if tree.is_executable(ie.file_id):
@@ -89,9 +92,13 @@
     ball.close()
 
 
-def tgz_exporter(tree, dest, root, subdir, filtered=False):
-    tar_exporter(tree, dest, root, subdir, compression='gz', filtered=filtered)
-
-
-def tbz_exporter(tree, dest, root, subdir, filtered=False):
-    tar_exporter(tree, dest, root, subdir, compression='bz2', filtered=filtered)
+def tgz_exporter(tree, dest, root, subdir, filtered=False,
+                 per_file_timestamps=False):
+    tar_exporter(tree, dest, root, subdir, compression='gz',
+                 filtered=filtered, per_file_timestamps=per_file_timestamps)
+
+
+def tbz_exporter(tree, dest, root, subdir, filtered=False,
+                 per_file_timestamps=False):
+    tar_exporter(tree, dest, root, subdir, compression='bz2',
+                 filtered=filtered, per_file_timestamps=per_file_timestamps)

=== modified file 'bzrlib/export/zip_exporter.py'
--- bzrlib/export/zip_exporter.py	2010-02-17 17:11:16 +0000
+++ bzrlib/export/zip_exporter.py	2010-03-08 02:23:17 +0000
@@ -42,7 +42,8 @@
 _DIR_ATTR = stat.S_IFDIR | ZIP_DIRECTORY_BIT
 
 
-def zip_exporter(tree, dest, root, subdir, filtered=False):
+def zip_exporter(tree, dest, root, subdir, filtered=False,
+                 per_file_timestamps=False):
     """ Export this tree to a new zip file.
 
     `dest` will be created holding the contents of this tree; if it
@@ -62,11 +63,15 @@
 
             # zipfile.ZipFile switches all paths to forward
             # slashes anyway, so just stick with that.
+            if per_file_timestamps:
+                mtime = tree.get_file_mtime(ie.file_id, dp)
+            else:
+                mtime = now
             filename = osutils.pathjoin(root, dp).encode('utf8')
             if ie.kind == "file":
                 zinfo = zipfile.ZipInfo(
                             filename=filename,
-                            date_time=now)
+                            date_time=mtime)
                 zinfo.compress_type = compression
                 zinfo.external_attr = _FILE_ATTR
                 if filtered:
@@ -84,14 +89,14 @@
                 # not just empty files.
                 zinfo = zipfile.ZipInfo(
                             filename=filename + '/',
-                            date_time=now)
+                            date_time=mtime)
                 zinfo.compress_type = compression
                 zinfo.external_attr = _DIR_ATTR
                 zipf.writestr(zinfo,'')
             elif ie.kind == "symlink":
                 zinfo = zipfile.ZipInfo(
                             filename=(filename + '.lnk'),
-                            date_time=now)
+                            date_time=mtime)
                 zinfo.compress_type = compression
                 zinfo.external_attr = _FILE_ATTR
                 zipf.writestr(zinfo, ie.symlink_target)

=== modified file 'bzrlib/help_topics/en/configuration.txt'
--- bzrlib/help_topics/en/configuration.txt	2010-01-03 03:33:10 +0000
+++ bzrlib/help_topics/en/configuration.txt	2010-03-24 13:58:37 +0000
@@ -98,25 +98,67 @@
 used literally, they will be substituted by the corresponding,
 platform specific, values.
 
-Examples:
-^^^^^^^^^
-
-The examples below uses ':' as the separator, windows users
+The examples below use ':' as the separator, windows users
 should use ';'.
 
-Overriding the default user plugin directory:
-``BZR_PLUGIN_PATH='/path/to/my/other/plugins'``
-
-Disabling the site directory while retaining the user directory:
-``BZR_PLUGIN_PATH='-site:+user'``
-
-Disabling all plugins (better achieved with --no-plugins):
-``BZR_PLUGIN_PATH='-user:-core:-site'``
-
-Overriding the default site plugin directory:
-``BZR_PLUGIN_PATH='/path/to/my/site/plugins:-site':+user``
-
-
+Overriding the default user plugin directory::
+
+  BZR_PLUGIN_PATH='/path/to/my/other/plugins'
+
+Disabling the site directory while retaining the user directory::
+
+  BZR_PLUGIN_PATH='-site:+user'
+
+Disabling all plugins (better achieved with --no-plugins)::
+
+  BZR_PLUGIN_PATH='-user:-core:-site'
+
+Overriding the default site plugin directory::
+
+  BZR_PLUGIN_PATH='/path/to/my/site/plugins:-site':+user
+
+BZR_DISABLE_PLUGINS
+~~~~~~~~~~~~~~~~~~~
+
+Under special circumstances (mostly when trying to diagnose a
+bug), it's better to disable a plugin (or several) rather than
+uninstalling them completely. Such plugins can be specified in
+the ``BZR_DISABLE_PLUGINS`` environment variable.
+
+In that case, ``bzr`` will stop loading the specified plugins and
+will raise an import error if they are explicitly imported (by
+another plugin that depends on them for example).
+
+Disabling ``myplugin`` and ``yourplugin`` is achieved by::
+
+  BZR_DISABLE_PLUGINS='myplugin:yourplugin'
+
+BZR_PLUGINS_AT
+~~~~~~~~~~~~~~
+
+When adding a new feature or working on a bug in a plugin,
+developers often need to use a specific version of a given
+plugin. Since python requires that the directory containing the
+code is named like the plugin itself this make it impossible to
+use arbitrary directory names (using a two-level directory scheme
+is inconvenient). ``BZR_PLUGINS_AT`` allows such directories even
+if they don't appear in ``BZR_PLUGIN_PATH`` .
+
+Plugins specified in this environment variable takes precedence
+over the ones in ``BZR_PLUGIN_PATH``.
+
+The variable specified a list of ``plugin_name@plugin path``,
+``plugin_name`` being the name of the plugin as it appears in
+python module paths, ``plugin_path`` being the path to the
+directory containing the plugin code itself
+(i.e. ``plugins/myplugin`` not ``plugins``).  Use ':' as the list
+separator, use ';' on windows.
+
+Example:
+~~~~~~~~
+
+Using a specific version of ``myplugin``:
+``BZR_PLUGINS_AT='myplugin@/home/me/bugfixes/123456-myplugin``
 
 BZRPATH
 ~~~~~~~

=== modified file 'bzrlib/hooks.py'
--- bzrlib/hooks.py	2010-02-17 17:11:16 +0000
+++ bzrlib/hooks.py	2010-03-12 19:59:50 +0000
@@ -59,7 +59,7 @@
     ('bzrlib.version_info_formats.format_rio', 'RioVersionInfoBuilder.hooks'),
     'bzrlib.version_info_formats.format_rio', 'RioVersionInfoBuilderHooks')
 known_hooks.register_lazy(
-    ('bzrlib.merge_directive', '_BaseMergeDirective.hooks'),
+    ('bzrlib.merge_directive', 'BaseMergeDirective.hooks'),
     'bzrlib.merge_directive', 'MergeDirectiveHooks')
 
 

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2010-02-23 07:43:11 +0000
+++ bzrlib/log.py	2010-03-19 10:16:06 +0000
@@ -553,11 +553,16 @@
                     # may not raise _StartNotLinearAncestor for a revision that
                     # is an ancestor but not a *linear* one. But since we have
                     # loaded the graph to do the check (or calculate a dotted
-                    # revno), we may as well accept to show the log... 
-                    # -- vila 100201
+                    # revno), we may as well accept to show the log...  We need
+                    # the check only if start_rev_id is not None as all
+                    # revisions have _mod_revision.NULL_REVISION as an ancestor
+                    # -- vila 20100319
                     graph = branch.repository.get_graph()
-                    if not graph.is_ancestor(start_rev_id, end_rev_id):
+                    if (start_rev_id is not None
+                        and not graph.is_ancestor(start_rev_id, end_rev_id)):
                         raise _StartNotLinearAncestor()
+                    # Since we collected the revisions so far, we need to
+                    # adjust end_rev_id.
                     end_rev_id = rev_id
                     break
                 else:
@@ -576,6 +581,9 @@
             raise errors.BzrCommandError('Start revision not found in'
                 ' history of end revision.')
 
+    # We exit the loop above because we encounter a revision with merges, from
+    # this revision, we need to switch to _graph_view_revisions.
+
     # A log including nested merges is required. If the direction is reverse,
     # we rebase the initial merge depths so that the development line is
     # shown naturally, i.e. just like it is for linear logging. We can easily
@@ -583,7 +591,7 @@
     # indented at the end seems slightly nicer in that case.
     view_revisions = chain(iter(initial_revisions),
         _graph_view_revisions(branch, start_rev_id, end_rev_id,
-        rebase_initial_depths=direction == 'reverse'))
+                              rebase_initial_depths=(direction == 'reverse')))
     if direction == 'reverse':
         return view_revisions
     elif direction == 'forward':
@@ -655,7 +663,7 @@
 
 
 def _graph_view_revisions(branch, start_rev_id, end_rev_id,
-    rebase_initial_depths=True):
+                          rebase_initial_depths=True):
     """Calculate revisions to view including merges, newest to oldest.
 
     :param branch: the branch
@@ -1424,7 +1432,8 @@
         """
         # Revision comes directly from a foreign repository
         if isinstance(rev, foreign.ForeignRevision):
-            return self._format_properties(rev.mapping.vcs.show_foreign_revid(rev.foreign_revid))
+            return self._format_properties(
+                rev.mapping.vcs.show_foreign_revid(rev.foreign_revid))
 
         # Imported foreign revision revision ids always contain :
         if not ":" in rev.revision_id:
@@ -2006,7 +2015,7 @@
         bug_rows = [line.split(' ', 1) for line in bug_lines]
         fixed_bug_urls = [row[0] for row in bug_rows if
                           len(row) > 1 and row[1] == 'fixed']
-        
+
         if fixed_bug_urls:
             return {'fixes bug(s)': ' '.join(fixed_bug_urls)}
     return {}

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2010-02-23 07:43:11 +0000
+++ bzrlib/merge.py	2010-03-09 15:33:25 +0000
@@ -1173,6 +1173,7 @@
         return 'conflict'
 
     @staticmethod
+    @deprecated_method(deprecated_in((2, 2, 0)))
     def scalar_three_way(this_tree, base_tree, other_tree, file_id, key):
         """Do a three-way test on a scalar.
         Return "this", "other" or "conflict", depending whether a value wins.

=== modified file 'bzrlib/merge_directive.py'
--- bzrlib/merge_directive.py	2010-02-17 17:11:16 +0000
+++ bzrlib/merge_directive.py	2010-03-13 02:49:14 +0000
@@ -64,10 +64,20 @@
             " provided to the next.", (1, 15, 0), False))
 
 
-class _BaseMergeDirective(object):
+class BaseMergeDirective(object):
+    """A request to perform a merge into a branch.
+
+    This is the base class that all merge directive implementations 
+    should derive from.
+
+    :cvar multiple_output_files: Whether or not this merge directive 
+        stores a set of revisions in more than one file
+    """
 
     hooks = MergeDirectiveHooks()
 
+    multiple_output_files = False
+
     def __init__(self, revision_id, testament_sha1, time, timezone,
                  target_branch, patch=None, source_branch=None, message=None,
                  bundle=None):
@@ -92,6 +102,27 @@
         self.source_branch = source_branch
         self.message = message
 
+    def to_lines(self):
+        """Serialize as a list of lines
+
+        :return: a list of lines
+        """
+        raise NotImplementedError(self.to_lines)
+
+    def to_files(self):
+        """Serialize as a set of files.
+
+        :return: List of tuples with filename and contents as lines
+        """
+        raise NotImplementedError(self.to_files)
+
+    def get_raw_bundle(self):
+        """Return the bundle for this merge directive.
+
+        :return: bundle text or None if there is no bundle
+        """
+        return None
+
     def _to_lines(self, base_revision=False):
         """Serialize as a list of lines
 
@@ -111,6 +142,13 @@
         lines.append('# \n')
         return lines
 
+    def write_to_directory(self, path):
+        """Write this merge directive to a series of files in a directory.
+
+        :param path: Filesystem path to write to
+        """
+        raise NotImplementedError(self.write_to_directory)
+
     @classmethod
     def from_objects(klass, repository, revision_id, time, timezone,
                  target_branch, patch_type='bundle',
@@ -303,7 +341,7 @@
                                           basename, body)
 
 
-class MergeDirective(_BaseMergeDirective):
+class MergeDirective(BaseMergeDirective):
 
     """A request to perform a merge into a branch.
 
@@ -338,7 +376,7 @@
         :param source_branch: A public location to merge the revision from
         :param message: The message to use when committing this merge
         """
-        _BaseMergeDirective.__init__(self, revision_id, testament_sha1, time,
+        BaseMergeDirective.__init__(self, revision_id, testament_sha1, time,
             timezone, target_branch, patch, source_branch, message)
         if patch_type not in (None, 'diff', 'bundle'):
             raise ValueError(patch_type)
@@ -428,7 +466,7 @@
         return None, self.revision_id, 'inapplicable'
 
 
-class MergeDirective2(_BaseMergeDirective):
+class MergeDirective2(BaseMergeDirective):
 
     _format_string = 'Bazaar merge directive format 2 (Bazaar 0.90)'
 
@@ -437,7 +475,7 @@
                  bundle=None, base_revision_id=None):
         if source_branch is None and bundle is None:
             raise errors.NoMergeSource()
-        _BaseMergeDirective.__init__(self, revision_id, testament_sha1, time,
+        BaseMergeDirective.__init__(self, revision_id, testament_sha1, time,
             timezone, target_branch, patch, source_branch, message)
         self.bundle = bundle
         self.base_revision_id = base_revision_id

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2010-03-05 08:55:12 +0000
+++ bzrlib/osutils.py	2010-03-11 06:35:52 +0000
@@ -51,7 +51,9 @@
     cache_utf8,
     errors,
     win32utils,
+    trace,
     )
+
 """)
 
 # sha and md5 modules are deprecated in python2.6 but hashlib is available as
@@ -1349,6 +1351,27 @@
     normalized_filename = _inaccessible_normalized_filename
 
 
+def set_signal_handler(signum, handler, restart_syscall=True):
+    """A wrapper for signal.signal that also calls siginterrupt(signum, False)
+    on platforms that support that.
+
+    :param restart_syscall: if set, allow syscalls interrupted by a signal to
+        automatically restart (by calling `signal.siginterrupt(signum,
+        False)`).  May be ignored if the feature is not available on this
+        platform or Python version.
+    """
+    old_handler = signal.signal(signum, handler)
+    if restart_syscall:
+        try:
+            siginterrupt = signal.siginterrupt
+        except AttributeError: # siginterrupt doesn't exist on this platform, or for this version of
+            # Python.
+            pass
+        else:
+            siginterrupt(signum, False)
+    return old_handler
+
+
 default_terminal_width = 80
 """The default terminal width for ttys.
 
@@ -1456,7 +1479,7 @@
             # the current design -- vila 20091216
             pass
         else:
-            signal.signal(signal.SIGWINCH, _terminal_size_changed)
+            set_signal_handler(signal.SIGWINCH, _terminal_size_changed)
         _registered_sigwinch = True
 
 
@@ -1783,6 +1806,51 @@
             real_handlers[kind](abspath, relpath)
 
 
+def copy_ownership(dst, src=None):
+    """Copy usr/grp ownership from src file/dir to dst file/dir.
+
+    If src is None, the containing directory is used as source. If chown
+    fails, the error is ignored and a warning is printed.
+    """
+    has_chown = getattr(os, 'chown')
+    if has_chown is None: return
+
+    if src == None:
+        src = os.path.dirname(dst)
+        if src == '':
+            src = '.'
+
+    try:
+        s = os.stat(src)
+        os.chown(dst, s.st_uid, s.st_gid)
+    except OSError, e:
+        trace.warning("Unable to copy ownership from '%s' to '%s': IOError: %s." % (src, dst, e))
+
+
+def mkdir_with_ownership(path, ownership_src=None):
+    """Create the directory 'path' with specified ownership.
+
+    If ownership_src is given, copies (chown) usr/grp ownership
+    from 'ownership_src' to 'path'. If ownership_src is None, use the
+    containing dir ownership.
+    """
+    os.mkdir(path)
+    copy_ownership(path, ownership_src)
+
+
+def open_with_ownership(filename, mode='r', bufsize=-1, ownership_src=None):
+    """Open the file 'filename' with the specified ownership.
+
+    If ownership_src is specified, copy usr/grp ownership from ownership_src
+    to filename. If ownership_src is None, copy ownership from containing
+    directory.
+    Returns the opened file object.
+    """
+    f = open(filename, mode, bufsize)
+    copy_ownership(filename, ownership_src)
+    return f
+
+
 def path_prefix_key(path):
     """Generate a prefix-order path key for path.
 

=== modified file 'bzrlib/pack.py'
--- bzrlib/pack.py	2009-07-02 03:48:25 +0000
+++ bzrlib/pack.py	2010-03-15 06:54:44 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009 Canonical Ltd
+# Copyright (C) 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -203,7 +203,7 @@
         result = self._string.readline()
         if self._string.tell() == self._string_length and result[-1] != '\n':
             raise errors.BzrError('short readline in the readvfile hunk: %r'
-                % (readline, ))
+                % (result, ))
         return result
 
 

=== modified file 'bzrlib/plugin.py'
--- bzrlib/plugin.py	2010-02-10 02:03:20 +0000
+++ bzrlib/plugin.py	2010-03-24 13:57:35 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005, 2007, 2008, 2010 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -67,15 +67,6 @@
     return _plugins_disabled
 
 
-@deprecated_function(deprecated_in((2, 0, 0)))
-def get_default_plugin_path():
-    """Get the DEFAULT_PLUGIN_PATH"""
-    global DEFAULT_PLUGIN_PATH
-    if DEFAULT_PLUGIN_PATH is None:
-        DEFAULT_PLUGIN_PATH = osutils.pathjoin(config.config_dir(), 'plugins')
-    return DEFAULT_PLUGIN_PATH
-
-
 def disable_plugins():
     """Disable loading plugins.
 
@@ -100,6 +91,19 @@
     if path is None:
         path = get_standard_plugins_path()
     _mod_plugins.__path__ = path
+    PluginImporter.reset()
+    # Set up a blacklist for disabled plugins
+    disabled_plugins = os.environ.get('BZR_DISABLE_PLUGINS', None)
+    if disabled_plugins is not None:
+        for name in disabled_plugins.split(os.pathsep):
+            PluginImporter.blacklist.add('bzrlib.plugins.' + name)
+    # Set up a the specific paths for plugins
+    specific_plugins = os.environ.get('BZR_PLUGINS_AT', None)
+    if specific_plugins is not None:
+        for spec in specific_plugins.split(os.pathsep):
+            plugin_name, plugin_path = spec.split('@')
+            PluginImporter.specific_paths[
+                'bzrlib.plugins.%s' % plugin_name] = plugin_path
     return path
 
 
@@ -188,12 +192,12 @@
     paths = []
     for p in env_paths + defaults:
         if p.startswith('+'):
-            # Resolve reference if they are known
+            # Resolve references if they are known
             try:
                 p = refs[p[1:]]
             except KeyError:
-                # Leave them untouched otherwise, user may have paths starting
-                # with '+'...
+                # Leave them untouched so user can still use paths starting
+                # with '+'
                 pass
         _append_new_path(paths, p)
 
@@ -211,7 +215,7 @@
     files (and whatever other extensions are used in the platform,
     such as *.pyd).
 
-    load_from_dirs() provides the underlying mechanism and is called with
+    load_from_path() provides the underlying mechanism and is called with
     the default directory list to provide the normal behaviour.
 
     :param path: The list of paths to search for plugins.  By default,
@@ -240,6 +244,11 @@
 
     The python module path for bzrlib.plugins will be modified to be 'dirs'.
     """
+    # Explicitly load the plugins with a specific path
+    for fullname, path in PluginImporter.specific_paths.iteritems():
+        name = fullname[len('bzrlib.plugins.'):]
+        _load_plugin_module(name, path)
+
     # We need to strip the trailing separators here as well as in the
     # set_plugins_path function because calling code can pass anything in to
     # this function, and since it sets plugins.__path__, it should set it to
@@ -259,70 +268,99 @@
 load_from_dirs = load_from_path
 
 
+def _find_plugin_module(dir, name):
+    """Check if there is a valid python module that can be loaded as a plugin.
+
+    :param dir: The directory where the search is performed.
+    :param path: An existing file path, either a python file or a package
+        directory.
+
+    :return: (name, path, description) name is the module name, path is the
+        file to load and description is the tuple returned by
+        imp.get_suffixes().
+    """
+    path = osutils.pathjoin(dir, name)
+    if os.path.isdir(path):
+        # Check for a valid __init__.py file, valid suffixes depends on -O and
+        # can be .py, .pyc and .pyo
+        for suffix, mode, kind in imp.get_suffixes():
+            if kind not in (imp.PY_SOURCE, imp.PY_COMPILED):
+                # We don't recognize compiled modules (.so, .dll, etc)
+                continue
+            init_path = osutils.pathjoin(path, '__init__' + suffix)
+            if os.path.isfile(init_path):
+                return name, init_path, (suffix, mode, kind)
+    else:
+        for suffix, mode, kind in imp.get_suffixes():
+            if name.endswith(suffix):
+                # Clean up the module name
+                name = name[:-len(suffix)]
+                if kind == imp.C_EXTENSION and name.endswith('module'):
+                    name = name[:-len('module')]
+                return name, path, (suffix, mode, kind)
+    # There is no python module here
+    return None, None, (None, None, None)
+
+
+def _load_plugin_module(name, dir):
+    """Load plugine name from dir.
+
+    :param name: The plugin name in the bzrlib.plugins namespace.
+    :param dir: The directory the plugin is loaded from for error messages.
+    """
+    if ('bzrlib.plugins.%s' % name) in PluginImporter.blacklist:
+        return
+    try:
+        exec "import bzrlib.plugins.%s" % name in {}
+    except KeyboardInterrupt:
+        raise
+    except errors.IncompatibleAPI, e:
+        trace.warning("Unable to load plugin %r. It requested API version "
+            "%s of module %s but the minimum exported version is %s, and "
+            "the maximum is %s" %
+            (name, e.wanted, e.api, e.minimum, e.current))
+    except Exception, e:
+        trace.warning("%s" % e)
+        if re.search('\.|-| ', name):
+            sanitised_name = re.sub('[-. ]', '_', name)
+            if sanitised_name.startswith('bzr_'):
+                sanitised_name = sanitised_name[len('bzr_'):]
+            trace.warning("Unable to load %r in %r as a plugin because the "
+                    "file path isn't a valid module name; try renaming "
+                    "it to %r." % (name, dir, sanitised_name))
+        else:
+            trace.warning('Unable to load plugin %r from %r' % (name, dir))
+        trace.log_exception_quietly()
+        if 'error' in debug.debug_flags:
+            trace.print_exception(sys.exc_info(), sys.stderr)
+
+
 def load_from_dir(d):
     """Load the plugins in directory d.
 
     d must be in the plugins module path already.
+    This function is called once for each directory in the module path.
     """
-    # Get the list of valid python suffixes for __init__.py?
-    # this includes .py, .pyc, and .pyo (depending on if we are running -O)
-    # but it doesn't include compiled modules (.so, .dll, etc)
-    valid_suffixes = [suffix for suffix, mod_type, flags in imp.get_suffixes()
-                              if flags in (imp.PY_SOURCE, imp.PY_COMPILED)]
-    package_entries = ['__init__'+suffix for suffix in valid_suffixes]
     plugin_names = set()
-    for f in os.listdir(d):
-        path = osutils.pathjoin(d, f)
-        if os.path.isdir(path):
-            for entry in package_entries:
-                # This directory should be a package, and thus added to
-                # the list
-                if os.path.isfile(osutils.pathjoin(path, entry)):
-                    break
-            else: # This directory is not a package
-                continue
-        else:
-            for suffix_info in imp.get_suffixes():
-                if f.endswith(suffix_info[0]):
-                    f = f[:-len(suffix_info[0])]
-                    if suffix_info[2] == imp.C_EXTENSION and f.endswith('module'):
-                        f = f[:-len('module')]
-                    break
+    for p in os.listdir(d):
+        name, path, desc = _find_plugin_module(d, p)
+        if name is not None:
+            if name == '__init__':
+                # We do nothing with the __init__.py file in directories from
+                # the bzrlib.plugins module path, we may want to, one day
+                # -- vila 20100316.
+                continue # We don't load __init__.py in the plugins dirs
+            elif getattr(_mod_plugins, name, None) is not None:
+                # The module has already been loaded from another directory
+                # during a previous call.
+                # FIXME: There should be a better way to report masked plugins
+                # -- vila 20100316
+                trace.mutter('Plugin name %s already loaded', name)
             else:
-                continue
-        if f == '__init__':
-            continue # We don't load __init__.py again in the plugin dir
-        elif getattr(_mod_plugins, f, None):
-            trace.mutter('Plugin name %s already loaded', f)
-        else:
-            # trace.mutter('add plugin name %s', f)
-            plugin_names.add(f)
+                plugin_names.add(name)
 
     for name in plugin_names:
-        try:
-            exec "import bzrlib.plugins.%s" % name in {}
-        except KeyboardInterrupt:
-            raise
-        except errors.IncompatibleAPI, e:
-            trace.warning("Unable to load plugin %r. It requested API version "
-                "%s of module %s but the minimum exported version is %s, and "
-                "the maximum is %s" %
-                (name, e.wanted, e.api, e.minimum, e.current))
-        except Exception, e:
-            trace.warning("%s" % e)
-            ## import pdb; pdb.set_trace()
-            if re.search('\.|-| ', name):
-                sanitised_name = re.sub('[-. ]', '_', name)
-                if sanitised_name.startswith('bzr_'):
-                    sanitised_name = sanitised_name[len('bzr_'):]
-                trace.warning("Unable to load %r in %r as a plugin because the "
-                        "file path isn't a valid module name; try renaming "
-                        "it to %r." % (name, d, sanitised_name))
-            else:
-                trace.warning('Unable to load plugin %r from %r' % (name, d))
-            trace.log_exception_quietly()
-            if 'error' in debug.debug_flags:
-                trace.print_exception(sys.exc_info(), sys.stderr)
+        _load_plugin_module(name, d)
 
 
 def plugins():
@@ -485,3 +523,75 @@
         return version_string
 
     __version__ = property(_get__version__)
+
+
+class _PluginImporter(object):
+    """An importer tailored to bzr specific needs.
+
+    This is a singleton that takes care of:
+    - disabled plugins specified in 'blacklist',
+    - plugins that needs to be loaded from specific directories.
+    """
+
+    def __init__(self):
+        self.reset()
+
+    def reset(self):
+        self.blacklist = set()
+        self.specific_paths = {}
+
+    def find_module(self, fullname, parent_path=None):
+        """Search a plugin module.
+
+        Disabled plugins raise an import error, plugins with specific paths
+        returns a specific loader.
+
+        :return: None if the plugin doesn't need special handling, self
+            otherwise.
+        """
+        if not fullname.startswith('bzrlib.plugins.'):
+            return None
+        if fullname in self.blacklist:
+            raise ImportError('%s is disabled' % fullname)
+        if fullname in self.specific_paths:
+            return self
+        return None
+
+    def load_module(self, fullname):
+        """Load a plugin from a specific directory."""
+        # We are called only for specific paths
+        plugin_dir = self.specific_paths[fullname]
+        candidate = None
+        maybe_package = False
+        for p in os.listdir(plugin_dir):
+            if os.path.isdir(osutils.pathjoin(plugin_dir, p)):
+                # We're searching for files only and don't want submodules to
+                # be recognized as plugins (they are submodules inside the
+                # plugin).
+                continue
+            name, path, (
+                suffix, mode, kind) = _find_plugin_module(plugin_dir, p)
+            if name is not None:
+                candidate = (name, path, suffix, mode, kind)
+                if kind == imp.PY_SOURCE:
+                    # We favour imp.PY_SOURCE (which will use the compiled
+                    # version if available) over imp.PY_COMPILED (which is used
+                    # only if the source is not available)
+                    break
+        if candidate is None:
+            raise ImportError('%s cannot be loaded from %s'
+                              % (fullname, plugin_dir))
+        f = open(path, mode)
+        try:
+            mod = imp.load_module(fullname, f, path, (suffix, mode, kind))
+            # The plugin can contain modules, so be ready
+            mod.__path__ = [plugin_dir]
+            mod.__package__ = fullname
+            return mod
+        finally:
+            f.close()
+
+
+# Install a dedicated importer for plugins requiring special handling
+PluginImporter = _PluginImporter()
+sys.meta_path.append(PluginImporter)

=== modified file 'bzrlib/reconfigure.py'
--- bzrlib/reconfigure.py	2009-10-06 14:40:37 +0000
+++ bzrlib/reconfigure.py	2010-03-25 09:39:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -368,7 +368,7 @@
             local_branch = self.local_branch
         if self._create_reference:
             format = branch.BranchReferenceFormat().initialize(self.bzrdir,
-                reference_branch)
+                target_branch=reference_branch)
         if self._destroy_tree:
             self.bzrdir.destroy_workingtree()
         if self._create_tree:

=== modified file 'bzrlib/remote.py'
--- bzrlib/remote.py	2010-03-09 23:48:40 +0000
+++ bzrlib/remote.py	2010-03-11 18:00:23 +0000
@@ -243,13 +243,13 @@
         self._real_bzrdir.destroy_repository()
 
     def create_branch(self, name=None):
-        if name is not None:
-            raise errors.NoColocatedBranchSupport(self)
         # as per meta1 formats - just delegate to the format object which may
         # be parameterised.
-        real_branch = self._format.get_branch_format().initialize(self)
+        real_branch = self._format.get_branch_format().initialize(self,
+            name=name)
         if not isinstance(real_branch, RemoteBranch):
-            result = RemoteBranch(self, self.find_repository(), real_branch)
+            result = RemoteBranch(self, self.find_repository(), real_branch,
+                                  name=name)
         else:
             result = real_branch
         # BzrDir.clone_on_transport() uses the result of create_branch but does
@@ -324,8 +324,6 @@
                     ignore_fallbacks=False):
         if unsupported:
             raise NotImplementedError('unsupported flag support not implemented yet.')
-        if name is not None:
-            raise errors.NoColocatedBranchSupport(self)
         if self._next_open_branch_result is not None:
             # See create_branch for details.
             result = self._next_open_branch_result
@@ -335,14 +333,14 @@
         if response[0] == 'ref':
             # a branch reference, use the existing BranchReference logic.
             format = BranchReferenceFormat()
-            return format.open(self, _found=True, location=response[1],
-                ignore_fallbacks=ignore_fallbacks)
+            return format.open(self, name=name, _found=True,
+                location=response[1], ignore_fallbacks=ignore_fallbacks)
         branch_format_name = response[1]
         if not branch_format_name:
             branch_format_name = None
         format = RemoteBranchFormat(network_name=branch_format_name)
         return RemoteBranch(self, self.find_repository(), format=format,
-            setup_stacking=not ignore_fallbacks)
+            setup_stacking=not ignore_fallbacks, name=name)
 
     def _open_repo_v1(self, path):
         verb = 'BzrDir.find_repository'
@@ -425,9 +423,9 @@
         """Return the path to be used for this bzrdir in a remote call."""
         return client.remote_path_from_transport(self.root_transport)
 
-    def get_branch_transport(self, branch_format):
+    def get_branch_transport(self, branch_format, name=None):
         self._ensure_real()
-        return self._real_bzrdir.get_branch_transport(branch_format)
+        return self._real_bzrdir.get_branch_transport(branch_format, name=name)
 
     def get_repository_transport(self, repository_format):
         self._ensure_real()
@@ -2027,26 +2025,29 @@
     def network_name(self):
         return self._network_name
 
-    def open(self, a_bzrdir, ignore_fallbacks=False):
-        return a_bzrdir.open_branch(ignore_fallbacks=ignore_fallbacks)
+    def open(self, a_bzrdir, name=None, ignore_fallbacks=False):
+        return a_bzrdir.open_branch(name=name, 
+            ignore_fallbacks=ignore_fallbacks)
 
-    def _vfs_initialize(self, a_bzrdir):
+    def _vfs_initialize(self, a_bzrdir, name):
         # Initialisation when using a local bzrdir object, or a non-vfs init
         # method is not available on the server.
         # self._custom_format is always set - the start of initialize ensures
         # that.
         if isinstance(a_bzrdir, RemoteBzrDir):
             a_bzrdir._ensure_real()
-            result = self._custom_format.initialize(a_bzrdir._real_bzrdir)
+            result = self._custom_format.initialize(a_bzrdir._real_bzrdir,
+                name)
         else:
             # We assume the bzrdir is parameterised; it may not be.
-            result = self._custom_format.initialize(a_bzrdir)
+            result = self._custom_format.initialize(a_bzrdir, name)
         if (isinstance(a_bzrdir, RemoteBzrDir) and
             not isinstance(result, RemoteBranch)):
-            result = RemoteBranch(a_bzrdir, a_bzrdir.find_repository(), result)
+            result = RemoteBranch(a_bzrdir, a_bzrdir.find_repository(), result,
+                                  name=name)
         return result
 
-    def initialize(self, a_bzrdir):
+    def initialize(self, a_bzrdir, name=None):
         # 1) get the network name to use.
         if self._custom_format:
             network_name = self._custom_format.network_name()
@@ -2058,20 +2059,23 @@
             network_name = reference_format.network_name()
         # Being asked to create on a non RemoteBzrDir:
         if not isinstance(a_bzrdir, RemoteBzrDir):
-            return self._vfs_initialize(a_bzrdir)
+            return self._vfs_initialize(a_bzrdir, name=name)
         medium = a_bzrdir._client._medium
         if medium._is_remote_before((1, 13)):
-            return self._vfs_initialize(a_bzrdir)
+            return self._vfs_initialize(a_bzrdir, name=name)
         # Creating on a remote bzr dir.
         # 2) try direct creation via RPC
         path = a_bzrdir._path_for_remote_call(a_bzrdir._client)
+        if name is not None:
+            # XXX JRV20100304: Support creating colocated branches
+            raise errors.NoColocatedBranchSupport(self)
         verb = 'BzrDir.create_branch'
         try:
             response = a_bzrdir._call(verb, path, network_name)
         except errors.UnknownSmartMethod:
             # Fallback - use vfs methods
             medium._remember_remote_is_before((1, 13))
-            return self._vfs_initialize(a_bzrdir)
+            return self._vfs_initialize(a_bzrdir, name=name)
         if response[0] != 'ok':
             raise errors.UnexpectedSmartServerResponse(response)
         # Turn the response into a RemoteRepository object.
@@ -2085,7 +2089,7 @@
                 a_bzrdir._client)
         remote_repo = RemoteRepository(repo_bzrdir, repo_format)
         remote_branch = RemoteBranch(a_bzrdir, remote_repo,
-            format=format, setup_stacking=False)
+            format=format, setup_stacking=False, name=name)
         # XXX: We know this is a new branch, so it must have revno 0, revid
         # NULL_REVISION. Creating the branch locked would make this be unable
         # to be wrong; here its simply very unlikely to be wrong. RBC 20090225
@@ -2118,7 +2122,7 @@
     """
 
     def __init__(self, remote_bzrdir, remote_repository, real_branch=None,
-        _client=None, format=None, setup_stacking=True):
+        _client=None, format=None, setup_stacking=True, name=None):
         """Create a RemoteBranch instance.
 
         :param real_branch: An optional local implementation of the branch
@@ -2130,6 +2134,7 @@
         :param setup_stacking: If True make an RPC call to determine the
             stacked (or not) status of the branch. If False assume the branch
             is not stacked.
+        :param name: Colocated branch name
         """
         # We intentionally don't call the parent class's __init__, because it
         # will try to assign to self.tags, which is a property in this subclass.
@@ -2155,6 +2160,7 @@
         # Fill out expected attributes of branch for bzrlib API users.
         self._clear_cached_state()
         self.base = self.bzrdir.root_transport.base
+        self._name = name
         self._control_files = None
         self._lock_mode = None
         self._lock_token = None
@@ -2225,7 +2231,7 @@
                     'to use vfs implementation')
             self.bzrdir._ensure_real()
             self._real_branch = self.bzrdir._real_bzrdir.open_branch(
-                ignore_fallbacks=self._real_ignore_fallbacks)
+                ignore_fallbacks=self._real_ignore_fallbacks, name=self._name)
             if self.repository._real_repository is None:
                 # Give the remote repository the matching real repo.
                 real_repo = self._real_branch.repository

=== modified file 'bzrlib/send.py'
--- bzrlib/send.py	2010-02-10 02:17:15 +0000
+++ bzrlib/send.py	2010-03-13 02:49:14 +0000
@@ -15,6 +15,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 
+import os
 import time
 
 from bzrlib import (
@@ -134,15 +135,29 @@
             directive.compose_merge_request(mail_client, mail_to, body,
                                             branch, tree)
         else:
-            if output == '-':
-                outfile = to_file
+            if directive.multiple_output_files:
+                if output == '-':
+                    raise errors.BzrCommandError('- not supported for '
+                        'merge directives that use more than one output file.')
+                if not os.path.exists(output):
+                    os.mkdir(output, 0755)
+                for (filename, lines) in directive.to_files():
+                    path = os.path.join(output, filename)
+                    outfile = open(path, 'wb')
+                    try:
+                        outfile.writelines(lines)
+                    finally:
+                        outfile.close()
             else:
-                outfile = open(output, 'wb')
-            try:
-                outfile.writelines(directive.to_lines())
-            finally:
-                if outfile is not to_file:
-                    outfile.close()
+                if output == '-':
+                    outfile = to_file
+                else:
+                    outfile = open(output, 'wb')
+                try:
+                    outfile.writelines(directive.to_lines())
+                finally:
+                    if outfile is not to_file:
+                        outfile.close()
     finally:
         branch.unlock()
 

=== modified file 'bzrlib/tag.py'
--- bzrlib/tag.py	2009-06-10 03:56:49 +0000
+++ bzrlib/tag.py	2010-03-25 09:39:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -26,8 +26,6 @@
 # called tags* are ctags files... mbp 20070220.
 
 
-from warnings import warn
-
 from bzrlib import (
     bencode,
     errors,
@@ -253,3 +251,4 @@
 
 def _merge_tags_if_possible(from_branch, to_branch):
     from_branch.tags.merge_to(to_branch.tags)
+

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2010-03-10 06:02:51 +0000
+++ bzrlib/tests/__init__.py	2010-03-24 13:58:37 +0000
@@ -1519,6 +1519,8 @@
             'BZR_PROGRESS_BAR': None,
             'BZR_LOG': None,
             'BZR_PLUGIN_PATH': None,
+            'BZR_DISABLE_PLUGINS': None,
+            'BZR_PLUGINS_AT': None,
             'BZR_CONCURRENCY': None,
             # Make sure that any text ui tests are consistent regardless of
             # the environment the test case is run in; you may want tests that

=== modified file 'bzrlib/tests/blackbox/__init__.py'
--- bzrlib/tests/blackbox/__init__.py	2009-04-29 20:31:34 +0000
+++ bzrlib/tests/blackbox/__init__.py	2010-03-25 09:39:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -95,6 +95,7 @@
                      'bzrlib.tests.blackbox.test_revno',
                      'bzrlib.tests.blackbox.test_revision_history',
                      'bzrlib.tests.blackbox.test_revision_info',
+                     'bzrlib.tests.blackbox.test_rmbranch',
                      'bzrlib.tests.blackbox.test_selftest',
                      'bzrlib.tests.blackbox.test_send',
                      'bzrlib.tests.blackbox.test_serve',

=== modified file 'bzrlib/tests/blackbox/test_annotate.py'
--- bzrlib/tests/blackbox/test_annotate.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/blackbox/test_annotate.py	2010-03-24 14:15:01 +0000
@@ -140,7 +140,7 @@
         out, err = self.run_bzr('annotate hello.txt -r 10',
                                 retcode=3)
         self.assertEqual('', out)
-        self.assertContainsRe(err, 'Requested revision: \'10\' does not exist')
+        self.assertContainsRe(err, "Requested revision: '10' does not exist")
 
     def test_annotate_cmd_two_revisions(self):
         out, err = self.run_bzr('annotate hello.txt -r1..2',

=== modified file 'bzrlib/tests/blackbox/test_break_lock.py'
--- bzrlib/tests/blackbox/test_break_lock.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/blackbox/test_break_lock.py	2010-03-25 09:39:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -60,7 +60,7 @@
         local_branch.bind(self.master_branch)
         checkoutdir = bzrlib.bzrdir.BzrDir.create('checkout')
         bzrlib.branch.BranchReferenceFormat().initialize(
-            checkoutdir, local_branch)
+            checkoutdir, target_branch=local_branch)
         self.wt = checkoutdir.create_workingtree()
 
     def test_break_lock_help(self):

=== modified file 'bzrlib/tests/blackbox/test_diff.py'
--- bzrlib/tests/blackbox/test_diff.py	2009-09-18 08:50:05 +0000
+++ bzrlib/tests/blackbox/test_diff.py	2010-03-24 14:15:01 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

=== modified file 'bzrlib/tests/blackbox/test_dump_btree.py'
--- bzrlib/tests/blackbox/test_dump_btree.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/blackbox/test_dump_btree.py	2010-03-25 09:39:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -78,3 +78,16 @@
             'test2\0key3\0ref\0entry3\0value3\n'
             '\n',
             out)
+
+    def test_dump_btree_no_refs_smoke(self):
+        # A BTree index with no ref lists (such as *.cix) can be dumped without
+        # errors.
+        builder = btree_index.BTreeBuilder(
+            reference_lists=0, key_elements=2)
+        builder.add_node(('test', 'key1'), 'value')
+        out_f = builder.finish()
+        try:
+            self.build_tree_contents([('test.btree', out_f.read())])
+        finally:
+            out_f.close()
+        out, err = self.run_bzr('dump-btree test.btree')

=== modified file 'bzrlib/tests/blackbox/test_export.py'
--- bzrlib/tests/blackbox/test_export.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/blackbox/test_export.py	2010-03-08 02:23:17 +0000
@@ -293,3 +293,13 @@
         tree.commit('more setup')
         out, err = self.run_bzr('export exported branch/subdir')
         self.assertEqual(['foo.txt'], os.listdir('exported'))
+
+    def test_dir_export_per_file_timestamps(self):
+        tree = self.example_branch()
+        self.build_tree_contents([('branch/har', 'foo')])
+        tree.add('har')
+        tree.commit('setup', timestamp=42)
+        self.run_bzr('export --per-file-timestamps t branch')
+        har_st = os.stat('t/har')
+        self.assertEquals(42, har_st.st_mtime)
+

=== modified file 'bzrlib/tests/blackbox/test_info.py'
--- bzrlib/tests/blackbox/test_info.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/blackbox/test_info.py	2010-03-02 22:25:58 +0000
@@ -1228,7 +1228,8 @@
         # Do a light checkout of the heavy one
         transport.mkdir('tree/lightcheckout')
         lco_dir = bzrdir.BzrDirMetaFormat1().initialize('tree/lightcheckout')
-        branch.BranchReferenceFormat().initialize(lco_dir, co_branch)
+        branch.BranchReferenceFormat().initialize(lco_dir,
+            target_branch=co_branch)
         lco_dir.create_workingtree()
         lco_tree = lco_dir.open_workingtree()
 

=== modified file 'bzrlib/tests/blackbox/test_log.py'
--- bzrlib/tests/blackbox/test_log.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/blackbox/test_log.py	2010-03-24 14:15:01 +0000
@@ -205,6 +205,14 @@
 
 class Test_GenerateAllRevisions(TestLogWithLogCatcher):
 
+    def setUp(self):
+        super(Test_GenerateAllRevisions, self).setUp()
+        builder = self.make_branch_with_many_merges()
+        b = builder.get_branch()
+        b.lock_read()
+        self.addCleanup(b.unlock)
+        self.branch = b
+
     def make_branch_with_many_merges(self, path='.', format=None):
         builder = branchbuilder.BranchBuilder(self.get_transport())
         builder.start_series()
@@ -226,25 +234,22 @@
         return builder
 
     def test_not_an_ancestor(self):
-        builder = self.make_branch_with_many_merges()
-        b = builder.get_branch()
-        b.lock_read()
-        self.addCleanup(b.unlock)
         self.assertRaises(errors.BzrCommandError,
                           log._generate_all_revisions,
-                          b, '1.1.1', '2.1.3', 'reverse',
+                          self.branch, '1.1.1', '2.1.3', 'reverse',
                           delayed_graph_generation=True)
 
     def test_wrong_order(self):
-        builder = self.make_branch_with_many_merges()
-        b = builder.get_branch()
-        b.lock_read()
-        self.addCleanup(b.unlock)
         self.assertRaises(errors.BzrCommandError,
                           log._generate_all_revisions,
-                          b, '5', '2.1.3', 'reverse',
+                          self.branch, '5', '2.1.3', 'reverse',
                           delayed_graph_generation=True)
 
+    def test_no_start_rev_id_with_end_rev_id_being_a_merge(self):
+        revs = log._generate_all_revisions(
+            self.branch, None, '2.1.3',
+            'reverse', delayed_graph_generation=True)
+
 
 class TestLogRevSpecsWithPaths(TestLogWithLogCatcher):
 

=== added file 'bzrlib/tests/blackbox/test_rmbranch.py'
--- bzrlib/tests/blackbox/test_rmbranch.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/blackbox/test_rmbranch.py	2010-03-22 10:11:00 +0000
@@ -0,0 +1,59 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+
+"""Black-box tests for bzr rmbranch."""
+
+from bzrlib import (
+    bzrdir,
+    )
+from bzrlib.tests.blackbox import (
+    ExternalBase,
+    )
+
+
+class TestRemoveBranch(ExternalBase):
+
+    def example_branch(self, path='.'):
+        tree = self.make_branch_and_tree(path)
+        self.build_tree_contents([(path + '/hello', 'foo')])
+        tree.add('hello')
+        tree.commit(message='setup')
+        self.build_tree_contents([(path + '/goodbye', 'baz')])
+        tree.add('goodbye')
+        tree.commit(message='setup')
+
+    def test_remove_local(self):
+        # Remove a local branch.
+        self.example_branch('a')
+        self.run_bzr('rmbranch a')
+        dir = bzrdir.BzrDir.open('a')
+        self.assertFalse(dir.has_branch())
+        self.failUnlessExists('a/hello')
+        self.failUnlessExists('a/goodbye')
+
+    def test_no_branch(self):
+        # No branch in the current directory. 
+        self.make_repository('a')
+        self.run_bzr_error(['Not a branch'],
+            'rmbranch a')
+
+    def test_no_arg(self):
+        # location argument defaults to current directory
+        self.example_branch('a')
+        self.run_bzr('rmbranch', working_dir='a')
+        dir = bzrdir.BzrDir.open('a')
+        self.assertFalse(dir.has_branch())

=== modified file 'bzrlib/tests/blackbox/test_status.py'
--- bzrlib/tests/blackbox/test_status.py	2009-07-08 14:37:25 +0000
+++ bzrlib/tests/blackbox/test_status.py	2010-03-25 09:39:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -498,7 +498,8 @@
     def make_branch_and_tree(self, relpath):
         source = self.make_branch(pathjoin('..', relpath))
         checkout = bzrdir.BzrDirMetaFormat1().initialize(relpath)
-        bzrlib.branch.BranchReferenceFormat().initialize(checkout, source)
+        bzrlib.branch.BranchReferenceFormat().initialize(checkout,
+            target_branch=source)
         return checkout.create_workingtree()
 
 
@@ -595,11 +596,28 @@
         result2 = self.run_bzr("status -SV -r 0..")[0]
         self.assertEquals(result2, result)
 
-    def assertStatusContains(self, pattern):
+    def assertStatusContains(self, pattern, short=False):
         """Run status, and assert it contains the given pattern"""
-        result = self.run_bzr("status --short")[0]
+        if short:
+            result = self.run_bzr("status --short")[0]
+        else:
+            result = self.run_bzr("status")[0]
         self.assertContainsRe(result, pattern)
 
+    def test_kind_change_plain(self):
+        tree = self.make_branch_and_tree('.')
+        self.build_tree(['file'])
+        tree.add('file')
+        tree.commit('added file')
+        unlink('file')
+        self.build_tree(['file/'])
+        self.assertStatusContains('kind changed:\n  file \(file => directory\)')
+        tree.rename_one('file', 'directory')
+        self.assertStatusContains('renamed:\n  file/ => directory/\n' \
+                                  'modified:\n  directory/\n')
+        rmdir('directory')
+        self.assertStatusContains('removed:\n  file\n')
+
     def test_kind_change_short(self):
         tree = self.make_branch_and_tree('.')
         self.build_tree(['file'])
@@ -607,11 +625,14 @@
         tree.commit('added file')
         unlink('file')
         self.build_tree(['file/'])
-        self.assertStatusContains('K  file => file/')
+        self.assertStatusContains('K  file => file/',
+                                   short=True)
         tree.rename_one('file', 'directory')
-        self.assertStatusContains('RK  file => directory/')
+        self.assertStatusContains('RK  file => directory/',
+                                   short=True)
         rmdir('directory')
-        self.assertStatusContains('RD  file => directory')
+        self.assertStatusContains('RD  file => directory',
+                                   short=True)
 
     def test_status_illegal_revision_specifiers(self):
         out, err = self.run_bzr('status -r 1..23..123', retcode=3)

=== modified file 'bzrlib/tests/blackbox/test_tags.py'
--- bzrlib/tests/blackbox/test_tags.py	2009-08-20 04:09:58 +0000
+++ bzrlib/tests/blackbox/test_tags.py	2010-03-24 14:16:15 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,7 +16,10 @@
 
 """Tests for commands related to tags"""
 
-from bzrlib import bzrdir
+from bzrlib import (
+    bzrdir,
+    tag,
+    )
 from bzrlib.branch import (
     Branch,
     )
@@ -47,6 +50,18 @@
         self.assertContainsRe(err,
             "Tags can only be placed on a single revision")
 
+    def test_no_tag_name(self):
+        out, err = self.run_bzr('tag -d branch', retcode=3)
+        self.assertContainsRe(err, 'Please specify a tag name.')
+
+    def test_automatic_tag_name(self):
+        def get_tag_name(branch, revid):
+            return "mytag"
+        Branch.hooks.install_named_hook('automatic_tag_name',
+            get_tag_name, 'get tag name')
+        out, err = self.run_bzr('tag -d branch')
+        self.assertContainsRe(out, 'Created tag mytag.')
+
     def test_tag_current_rev(self):
         t = self.make_branch_and_tree('branch')
         t.commit(allow_pointless=True, message='initial commit',
@@ -73,6 +88,10 @@
         # ... but can if you use --force
         out, err = self.run_bzr('tag -d branch NEWTAG --force')
 
+    def test_tag_delete_requires_name(self):
+        out, err = self.run_bzr('tag -d branch', retcode=3)
+        self.assertContainsRe(err, 'Please specify a tag name\\.')
+
     def test_branch_push_pull_merge_copies_tags(self):
         t = self.make_branch_and_tree('branch1')
         t.commit(allow_pointless=True, message='initial commit',

=== modified file 'bzrlib/tests/blackbox/test_update.py'
--- bzrlib/tests/blackbox/test_update.py	2010-03-05 08:55:12 +0000
+++ bzrlib/tests/blackbox/test_update.py	2010-03-11 11:07:32 +0000
@@ -195,7 +195,8 @@
 
         self.build_tree(['checkout1/'])
         checkout_dir = bzrdir.BzrDirMetaFormat1().initialize('checkout1')
-        branch.BranchReferenceFormat().initialize(checkout_dir, master.branch)
+        branch.BranchReferenceFormat().initialize(checkout_dir,
+            target_branch=master.branch)
         checkout1 = checkout_dir.create_workingtree('m1')
 
         # Create a second branch, with an extra commit

=== modified file 'bzrlib/tests/blackbox/test_upgrade.py'
--- bzrlib/tests/blackbox/test_upgrade.py	2010-02-15 11:28:35 +0000
+++ bzrlib/tests/blackbox/test_upgrade.py	2010-03-25 09:39:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2009 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,12 +15,15 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 """Black box tests for the upgrade ui."""
+import os
+import stat
 
 from bzrlib import (
     bzrdir,
     repository,
     )
 from bzrlib.tests import (
+    features,
     TestCaseInTempDir,
     TestCaseWithTransport,
     )
@@ -146,6 +149,17 @@
         self.run_bzr('init-repository --format=metaweave repo')
         self.run_bzr('upgrade --format=knit repo')
 
+    def test_upgrade_permission_check(self):
+        """'backup.bzr' should retain permissions of .bzr. Bug #262450"""
+        self.requireFeature(features.posix_permissions_feature)
+        old_perms = stat.S_IRUSR | stat.S_IWUSR | stat.S_IXUSR
+        backup_dir = 'backup.bzr.~1~'
+        self.run_bzr('init --format=1.6')
+        os.chmod('.bzr', old_perms)
+        self.run_bzr('upgrade')
+        new_perms = os.stat(backup_dir).st_mode & 0777
+        self.assertTrue(new_perms == old_perms)
+
 
     def test_upgrade_with_existing_backup_dir(self):
         self.make_format_5_branch()

=== modified file 'bzrlib/tests/features.py'
--- bzrlib/tests/features.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/features.py	2010-03-18 06:25:23 +0000
@@ -14,6 +14,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+import os
+import stat
 
 from bzrlib import tests
 from bzrlib.symbol_versioning import deprecated_in
@@ -23,3 +25,39 @@
 paramiko = tests.ModuleAvailableFeature('paramiko')
 pycurl = tests.ModuleAvailableFeature('pycurl')
 subunit = tests.ModuleAvailableFeature('subunit')
+
+
+class _PosixPermissionsFeature(tests.Feature):
+
+    def _probe(self):
+        def has_perms():
+            # create temporary file and check if specified perms are maintained.
+            import tempfile
+
+            write_perms = stat.S_IRUSR | stat.S_IWUSR | stat.S_IXUSR
+            f = tempfile.mkstemp(prefix='bzr_perms_chk_')
+            fd, name = f
+            os.close(fd)
+            os.chmod(name, write_perms)
+
+            read_perms = os.stat(name).st_mode & 0777
+            os.unlink(name)
+            return (write_perms == read_perms)
+
+        return (os.name == 'posix') and has_perms()
+
+    def feature_name(self):
+        return 'POSIX permissions support'
+
+
+posix_permissions_feature = _PosixPermissionsFeature()
+
+
+class _ChownFeature(tests.Feature):
+    """os.chown is supported"""
+
+    def _probe(self):
+        return os.name == 'posix' and hasattr(os, 'chown')
+
+chown_feature = _ChownFeature()
+

=== modified file 'bzrlib/tests/per_branch/test_branch.py'
--- bzrlib/tests/per_branch/test_branch.py	2010-02-11 09:27:55 +0000
+++ bzrlib/tests/per_branch/test_branch.py	2010-03-02 22:25:58 +0000
@@ -379,6 +379,23 @@
         self.assertEqual(committed.properties["branch-nick"],
                          "My happy branch")
 
+    def test_create_colocated(self):
+        try:
+            repo = self.make_repository('.', shared=True)
+        except errors.IncompatibleFormat:
+            return
+        self.assertEquals(0, len(repo.bzrdir.list_branches()))
+        try:
+            child_branch1 = self.branch_format.initialize(repo.bzrdir, 
+                name='branch1')
+        except (errors.UninitializableFormat, errors.NoColocatedBranchSupport):
+            # branch references are not default init'able and
+            # not all bzrdirs support colocated branches.
+            return
+        self.assertEquals(1, len(repo.bzrdir.list_branches()))
+        self.branch_format.initialize(repo.bzrdir, name='branch2')
+        self.assertEquals(2, len(repo.bzrdir.list_branches()))
+
     def test_create_open_branch_uses_repository(self):
         try:
             repo = self.make_repository('.', shared=True)

=== modified file 'bzrlib/tests/per_branch/test_iter_merge_sorted_revisions.py'
--- bzrlib/tests/per_branch/test_iter_merge_sorted_revisions.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/per_branch/test_iter_merge_sorted_revisions.py	2010-03-19 12:42:56 +0000
@@ -19,178 +19,110 @@
 from bzrlib import (
     errors,
     revision,
+    tests,
     )
 
-from bzrlib.tests.per_branch import TestCaseWithBranch
-
-
-class TestIterMergeSortedRevisions(TestCaseWithBranch):
+from bzrlib.tests import per_branch
+
+
+class TestIterMergeSortedRevisions(per_branch.TestCaseWithBranch):
+
+    def setUp(self):
+        super(TestIterMergeSortedRevisions, self).setUp()
+        self.branch = self.make_branch_with_merges('.')
+
+    def make_branch_with_merges(self, relpath):
+        try:
+            builder = self.make_branch_builder(relpath)
+        except (errors.TransportNotPossible, errors.UninitializableFormat):
+            raise tests.TestNotApplicable('format not directly constructable')
+        builder.start_series()
+        builder.build_snapshot('1', None, [
+            ('add', ('', 'TREE_ROOT', 'directory', '')),])
+        builder.build_snapshot('1.1.1', ['1'], [])
+        builder.build_snapshot('2', ['1'], [])
+        builder.build_snapshot('3', ['2', '1.1.1'], [])
+        builder.finish_series()
+        return builder.get_branch()
+
+
+    def assertIterRevids(self, expected, *args, **kwargs):
+        # We don't care about depths and revnos here, only about returning the
+        # right revids.
+        revids = [ revid for (revid, depth, revno, eom) in
+                   self.branch.iter_merge_sorted_revisions(*args, **kwargs)]
+        self.assertEqual(expected, revids)
 
     def test_merge_sorted(self):
-        tree = self.create_tree_with_merge()
-        the_branch = tree.bzrdir.open_branch()
-        self.assertEqual([
-            ('rev-3', 0, (3,), False),
-            ('rev-1.1.1', 1, (1,1,1), True),
-            ('rev-2', 0, (2,), False),
-            ('rev-1', 0, (1,), True),
-            ], list(the_branch.iter_merge_sorted_revisions()))
+        self.assertIterRevids(['3', '1.1.1', '2', '1'])
 
     def test_merge_sorted_range(self):
-        tree = self.create_tree_with_merge()
-        the_branch = tree.bzrdir.open_branch()
-        self.assertEqual([
-            ('rev-1.1.1', 1, (1,1,1), True),
-            ('rev-2', 0, (2,), False),
-            ], list(the_branch.iter_merge_sorted_revisions(
-                start_revision_id='rev-1.1.1', stop_revision_id='rev-1')))
+        self.assertIterRevids(['1.1.1', '2'],
+                              start_revision_id='1.1.1', stop_revision_id='1')
 
     def test_merge_sorted_range_start_only(self):
-        tree = self.create_tree_with_merge()
-        the_branch = tree.bzrdir.open_branch()
-        self.assertEqual([
-            ('rev-1.1.1', 1, (1,1,1), True),
-            ('rev-2', 0, (2,), False),
-            ('rev-1', 0, (1,), True),
-            ], list(the_branch.iter_merge_sorted_revisions(
-                start_revision_id='rev-1.1.1')))
+        self.assertIterRevids(['1.1.1', '2', '1'],
+                              start_revision_id='1.1.1')
 
     def test_merge_sorted_range_stop_exclude(self):
-        tree = self.create_tree_with_merge()
-        the_branch = tree.bzrdir.open_branch()
-        self.assertEqual([
-            ('rev-3', 0, (3,), False),
-            ('rev-1.1.1', 1, (1,1,1), True),
-            ('rev-2', 0, (2,), False),
-            ], list(the_branch.iter_merge_sorted_revisions(
-                stop_revision_id='rev-1')))
+        self.assertIterRevids(['3', '1.1.1', '2'], stop_revision_id='1')
 
     def test_merge_sorted_range_stop_include(self):
-        tree = self.create_tree_with_merge()
-        the_branch = tree.bzrdir.open_branch()
-        self.assertEqual([
-            ('rev-3', 0, (3,), False),
-            ('rev-1.1.1', 1, (1,1,1), True),
-            ('rev-2', 0, (2,), False),
-            ], list(the_branch.iter_merge_sorted_revisions(
-                stop_revision_id='rev-2', stop_rule='include')))
+        self.assertIterRevids(['3', '1.1.1', '2'],
+                              stop_revision_id='2', stop_rule='include')
 
     def test_merge_sorted_range_stop_with_merges(self):
-        tree = self.create_tree_with_merge()
-        the_branch = tree.bzrdir.open_branch()
-        self.assertEqual([
-            ('rev-3', 0, (3,), False),
-            ('rev-1.1.1', 1, (1,1,1), True),
-            ], list(the_branch.iter_merge_sorted_revisions(
-                stop_revision_id='rev-3', stop_rule='with-merges')))
+        self.assertIterRevids(['3', '1.1.1'],
+                              stop_revision_id='3', stop_rule='with-merges')
 
     def test_merge_sorted_range_stop_with_merges_can_show_non_parents(self):
-        tree = self.create_tree_with_merge()
-        the_branch = tree.bzrdir.open_branch()
-        # rev-1.1.1 gets logged before the end revision is reached.
-        # so it is returned even though rev-1.1.1 is not a parent of rev-2.
-        self.assertEqual([
-            ('rev-3', 0, (3,), False),
-            ('rev-1.1.1', 1, (1,1,1), True),
-            ('rev-2', 0, (2,), False),
-            ], list(the_branch.iter_merge_sorted_revisions(
-                stop_revision_id='rev-2', stop_rule='with-merges')))
+        # 1.1.1 gets logged before the end revision is reached.
+        # so it is returned even though 1.1.1 is not a parent of 2.
+        self.assertIterRevids(['3', '1.1.1', '2'],
+                              stop_revision_id='2', stop_rule='with-merges')
 
     def test_merge_sorted_range_stop_with_merges_ignore_non_parents(self):
-        tree = self.create_tree_with_merge()
-        the_branch = tree.bzrdir.open_branch()
-        # rev-2 is not a parent of rev-1.1.1 so it must not be returned
-        self.assertEqual([
-            ('rev-3', 0, (3,), False),
-            ('rev-1.1.1', 1, (1,1,1), True),
-            ], list(the_branch.iter_merge_sorted_revisions(
-                stop_revision_id='rev-1.1.1', stop_rule='with-merges')))
+        # 2 is not a parent of 1.1.1 so it must not be returned
+        self.assertIterRevids(['3', '1.1.1'],
+                              stop_revision_id='1.1.1', stop_rule='with-merges')
 
     def test_merge_sorted_single_stop_exclude(self):
         # from X..X exclusive is an empty result
-        tree = self.create_tree_with_merge()
-        the_branch = tree.bzrdir.open_branch()
-        self.assertEqual([], list(the_branch.iter_merge_sorted_revisions(
-                start_revision_id='rev-3', stop_revision_id='rev-3')))
+        self.assertIterRevids([], start_revision_id='3', stop_revision_id='3')
 
     def test_merge_sorted_single_stop_include(self):
         # from X..X inclusive is [X]
-        tree = self.create_tree_with_merge()
-        the_branch = tree.bzrdir.open_branch()
-        self.assertEqual([
-            ('rev-3', 0, (3,), False),
-            ], list(the_branch.iter_merge_sorted_revisions(
-                start_revision_id='rev-3', stop_revision_id='rev-3',
-                stop_rule='include')))
+        self.assertIterRevids(['3'],
+                              start_revision_id='3', stop_revision_id='3',
+                              stop_rule='include')
 
     def test_merge_sorted_single_stop_with_merges(self):
-        tree = self.create_tree_with_merge()
-        the_branch = tree.bzrdir.open_branch()
-        self.assertEqual([
-            ('rev-3', 0, (3,), False),
-            ('rev-1.1.1', 1, (1,1,1), True),
-            ], list(the_branch.iter_merge_sorted_revisions(
-                start_revision_id='rev-3', stop_revision_id='rev-3',
-                stop_rule='with-merges')))
+        self.assertIterRevids(['3', '1.1.1'],
+                              start_revision_id='3', stop_revision_id='3',
+                              stop_rule='with-merges')
 
     def test_merge_sorted_forward(self):
-        tree = self.create_tree_with_merge()
-        the_branch = tree.bzrdir.open_branch()
-        self.assertEqual([
-            ('rev-1', 0, (1,), True),
-            ('rev-2', 0, (2,), False),
-            ('rev-1.1.1', 1, (1,1,1), True),
-            ('rev-3', 0, (3,), False),
-            ], list(the_branch.iter_merge_sorted_revisions(
-                direction='forward')))
+        self.assertIterRevids(['1', '2', '1.1.1', '3'], direction='forward')
 
     def test_merge_sorted_range_forward(self):
-        tree = self.create_tree_with_merge()
-        the_branch = tree.bzrdir.open_branch()
-        self.assertEqual([
-            ('rev-2', 0, (2,), False),
-            ('rev-1.1.1', 1, (1,1,1), True),
-            ], list(the_branch.iter_merge_sorted_revisions(
-                start_revision_id='rev-1.1.1', stop_revision_id='rev-1',
-                direction='forward')))
+        self.assertIterRevids(['2', '1.1.1'],
+                              start_revision_id='1.1.1', stop_revision_id='1',
+                              direction='forward')
 
     def test_merge_sorted_range_start_only_forward(self):
-        tree = self.create_tree_with_merge()
-        the_branch = tree.bzrdir.open_branch()
-        self.assertEqual([
-            ('rev-1', 0, (1,), True),
-            ('rev-2', 0, (2,), False),
-            ('rev-1.1.1', 1, (1,1,1), True),
-            ], list(the_branch.iter_merge_sorted_revisions(
-                start_revision_id='rev-1.1.1', direction='forward')))
+        self.assertIterRevids(['1', '2', '1.1.1'],
+                              start_revision_id='1.1.1', direction='forward')
 
     def test_merge_sorted_range_stop_exclude_forward(self):
-        tree = self.create_tree_with_merge()
-        the_branch = tree.bzrdir.open_branch()
-        self.assertEqual([
-            ('rev-2', 0, (2,), False),
-            ('rev-1.1.1', 1, (1,1,1), True),
-            ('rev-3', 0, (3,), False),
-            ], list(the_branch.iter_merge_sorted_revisions(
-                stop_revision_id='rev-1', direction='forward')))
+        self.assertIterRevids(['2', '1.1.1', '3'],
+                              stop_revision_id='1', direction='forward')
 
     def test_merge_sorted_range_stop_include_forward(self):
-        tree = self.create_tree_with_merge()
-        the_branch = tree.bzrdir.open_branch()
-        self.assertEqual([
-            ('rev-2', 0, (2,), False),
-            ('rev-1.1.1', 1, (1,1,1), True),
-            ('rev-3', 0, (3,), False),
-            ], list(the_branch.iter_merge_sorted_revisions(
-                stop_revision_id='rev-2', stop_rule='include',
-                direction='forward')))
+        self.assertIterRevids(['2', '1.1.1', '3'],
+                              stop_revision_id='2', stop_rule='include',
+                              direction='forward')
 
     def test_merge_sorted_range_stop_with_merges_forward(self):
-        tree = self.create_tree_with_merge()
-        the_branch = tree.bzrdir.open_branch()
-        self.assertEqual([
-            ('rev-1.1.1', 1, (1,1,1), True),
-            ('rev-3', 0, (3,), False),
-            ], list(the_branch.iter_merge_sorted_revisions(
-                stop_revision_id='rev-3', stop_rule='with-merges',
-                direction='forward')))
+        self.assertIterRevids(['1.1.1', '3'],
+                              stop_revision_id='3', stop_rule='with-merges',
+                              direction='forward')

=== modified file 'bzrlib/tests/per_branch/test_tags.py'
--- bzrlib/tests/per_branch/test_tags.py	2010-02-10 17:52:08 +0000
+++ bzrlib/tests/per_branch/test_tags.py	2010-03-12 02:14:56 +0000
@@ -171,3 +171,54 @@
         b1 = self.make_branch('b1')
         b2 = self.make_branch('b2')
         b1.tags.merge_to(b2.tags)
+
+
+class AutomaticTagNameTests(per_branch.TestCaseWithBranch):
+
+    def setUp(self):
+        super(AutomaticTagNameTests, self).setUp()
+        if isinstance(self.branch_format, branch.BranchReferenceFormat):
+            # This test could in principle apply to BranchReferenceFormat, but
+            # make_branch_builder doesn't support it.
+            raise tests.TestSkipped(
+                "BranchBuilder can't make reference branches.")
+        self.builder = self.make_branch_builder('.')
+        self.builder.build_snapshot('foo', None,
+            [('add', ('', None, 'directory', None))],
+            message='foo')
+        self.branch = self.builder.get_branch()
+        if not self.branch._format.supports_tags():
+            raise tests.TestSkipped(
+                "format %s doesn't support tags" % self.branch._format)
+
+    def test_no_functions(self):
+        rev = self.branch.last_revision()
+        self.assertEquals(None, self.branch.automatic_tag_name(rev))
+
+    def test_returns_tag_name(self):
+        def get_tag_name(br, revid):
+            return "foo"
+        branch.Branch.hooks.install_named_hook('automatic_tag_name',
+            get_tag_name, 'get tag name foo')
+        self.assertEquals("foo", self.branch.automatic_tag_name(
+            self.branch.last_revision()))
+    
+    def test_uses_first_return(self):
+        get_tag_name_1 = lambda br, revid: "foo1"
+        get_tag_name_2 = lambda br, revid: "foo2"
+        branch.Branch.hooks.install_named_hook('automatic_tag_name',
+            get_tag_name_1, 'tagname1')
+        branch.Branch.hooks.install_named_hook('automatic_tag_name',
+            get_tag_name_2, 'tagname2')
+        self.assertEquals("foo1", self.branch.automatic_tag_name(
+            self.branch.last_revision()))
+
+    def test_ignores_none(self):
+        get_tag_name_1 = lambda br, revid: None
+        get_tag_name_2 = lambda br, revid: "foo2"
+        branch.Branch.hooks.install_named_hook('automatic_tag_name',
+            get_tag_name_1, 'tagname1')
+        branch.Branch.hooks.install_named_hook('automatic_tag_name',
+            get_tag_name_2, 'tagname2')
+        self.assertEquals("foo2", self.branch.automatic_tag_name(
+            self.branch.last_revision()))

=== modified file 'bzrlib/tests/per_bzrdir/test_bzrdir.py'
--- bzrlib/tests/per_bzrdir/test_bzrdir.py	2010-03-02 19:50:18 +0000
+++ bzrlib/tests/per_bzrdir/test_bzrdir.py	2010-03-02 22:25:58 +0000
@@ -534,7 +534,7 @@
         dir = self.make_bzrdir('source')
         try:
             reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
-                referenced_branch)
+                target_branch=referenced_branch)
         except errors.IncompatibleFormat:
             # this is ok too, not all formats have to support references.
             return
@@ -637,7 +637,7 @@
         dir = self.make_bzrdir('source')
         try:
             reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
-                referenced_branch)
+                target_branch=referenced_branch)
         except errors.IncompatibleFormat:
             # this is ok too, not all formats have to support references.
             return
@@ -702,7 +702,7 @@
         dir = self.make_bzrdir('source')
         try:
             reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
-                referenced_branch)
+                target_branch=referenced_branch)
         except errors.IncompatibleFormat:
             # this is ok too, not all formats have to support references.
             return
@@ -977,7 +977,7 @@
         dir = self.make_bzrdir('source')
         try:
             reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
-                referenced_branch)
+                target_branch=referenced_branch)
         except errors.IncompatibleFormat:
             # this is ok too, not all formats have to support references.
             return
@@ -997,7 +997,7 @@
         dir = self.make_bzrdir('source')
         try:
             reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
-                referenced_tree.branch)
+                target_branch=referenced_tree.branch)
         except errors.IncompatibleFormat:
             # this is ok too, not all formats have to support references.
             return
@@ -1023,7 +1023,7 @@
         dir = self.make_bzrdir('source')
         try:
             reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
-                referenced_tree.branch)
+                target_branch=referenced_tree.branch)
         except errors.IncompatibleFormat:
             # this is ok too, not all formats have to support references.
             return
@@ -1088,7 +1088,7 @@
         dir = self.make_bzrdir('source')
         try:
             reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
-                referenced_branch)
+                target_branch=referenced_branch)
         except errors.IncompatibleFormat:
             # this is ok too, not all formats have to support references.
             return
@@ -1114,7 +1114,7 @@
         dir = self.make_bzrdir('source')
         try:
             reference = bzrlib.branch.BranchReferenceFormat().initialize(dir,
-                referenced_branch)
+                target_branch=referenced_branch)
         except errors.IncompatibleFormat:
             # this is ok too, not all formats have to support references.
             return
@@ -1886,7 +1886,7 @@
         thisdir = self.make_bzrdir('this')
         try:
             bzrlib.branch.BranchReferenceFormat().initialize(
-                thisdir, master)
+                thisdir, target_branch=master)
         except errors.IncompatibleFormat:
             return
         unused_repo = thisdir.create_repository()

=== modified file 'bzrlib/tests/per_transport.py'
--- bzrlib/tests/per_transport.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/per_transport.py	2010-03-05 05:30:19 +0000
@@ -1083,6 +1083,52 @@
         subdir.stat('./file')
         subdir.stat('.')
 
+    def test_hardlink(self):
+        from stat import ST_NLINK
+
+        t = self.get_transport()
+
+        source_name = "original_target"
+        link_name = "target_link"
+
+        self.build_tree([source_name], transport=t)
+
+        try:
+            t.hardlink(source_name, link_name)
+
+            self.failUnless(t.has(source_name))
+            self.failUnless(t.has(link_name))
+
+            st = t.stat(link_name)
+            self.failUnlessEqual(st[ST_NLINK], 2)
+        except TransportNotPossible:
+            raise TestSkipped("Transport %s does not support hardlinks." %
+                              self._server.__class__)
+
+    def test_symlink(self):
+        from stat import S_ISLNK
+
+        t = self.get_transport()
+
+        source_name = "original_target"
+        link_name = "target_link"
+
+        self.build_tree([source_name], transport=t)
+
+        try:
+            t.symlink(source_name, link_name)
+
+            self.failUnless(t.has(source_name))
+            self.failUnless(t.has(link_name))
+
+            st = t.stat(link_name)
+            self.failUnless(S_ISLNK(st.st_mode))
+        except TransportNotPossible:
+            raise TestSkipped("Transport %s does not support symlinks." %
+                              self._server.__class__)
+        except IOError:
+            raise tests.KnownFailure("Paramiko fails to create symlinks during tests")
+
     def test_list_dir(self):
         # TODO: Test list_dir, just try once, and if it throws, stop testing
         t = self.get_transport()

=== modified file 'bzrlib/tests/per_tree/test_get_file_mtime.py'
--- bzrlib/tests/per_tree/test_get_file_mtime.py	2009-07-10 07:14:02 +0000
+++ bzrlib/tests/per_tree/test_get_file_mtime.py	2010-03-17 13:03:38 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -38,6 +38,7 @@
         # file, working trees return the on-disk time.
         mtime_file_id = tree.get_file_mtime(file_id='one-id')
         self.assertIsInstance(mtime_file_id, (float, int))
-        self.failUnless(now - 5 < mtime_file_id < now + 5)
+        self.failUnless(now - 5 < mtime_file_id < now + 5,
+                        'now: %f, mtime_file_id: %f' % (now, mtime_file_id ))
         mtime_path = tree.get_file_mtime(file_id='one-id', path='one')
         self.assertEqual(mtime_file_id, mtime_path)

=== modified file 'bzrlib/tests/per_tree/test_revision_tree.py'
--- bzrlib/tests/per_tree/test_revision_tree.py	2009-07-10 07:14:02 +0000
+++ bzrlib/tests/per_tree/test_revision_tree.py	2010-03-10 09:26:51 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,11 +16,14 @@
 
 """Tests for Tree.revision_tree."""
 
-from bzrlib import errors
-from bzrlib.tests.per_tree import TestCaseWithTree
-
-
-class TestRevisionTree(TestCaseWithTree):
+from bzrlib import (
+    errors,
+    tests,
+    )
+from bzrlib.tests import per_tree
+
+
+class TestRevisionTree(per_tree.TestCaseWithTree):
 
     def create_tree_no_parents_no_content(self):
         tree = self.make_branch_and_tree('.')

=== modified file 'bzrlib/tests/per_workingtree/test_revision_tree.py'
--- bzrlib/tests/per_workingtree/test_revision_tree.py	2009-07-10 07:14:02 +0000
+++ bzrlib/tests/per_workingtree/test_revision_tree.py	2010-03-10 09:33:04 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -23,11 +23,15 @@
 so these tests are testing that when there is a cache, it performs correctly.
 """
 
-from bzrlib import errors
-from bzrlib.tests.per_workingtree import TestCaseWithWorkingTree
-
-
-class TestRevisionTree(TestCaseWithWorkingTree):
+from bzrlib import (
+    branchbuilder,
+    errors,
+    tests,
+    )
+from bzrlib.tests import per_workingtree
+
+
+class TestRevisionTree(per_workingtree.TestCaseWithWorkingTree):
 
     def test_get_zeroth_basis_tree_via_revision_tree(self):
         tree = self.make_branch_and_tree('.')
@@ -83,3 +87,50 @@
             return
         repository_revision_tree = tree.branch.repository.revision_tree(rev1)
         self.assertTreesEqual(repository_revision_tree, cached_revision_tree)
+
+
+class TestRevisionTreeKind(per_workingtree.TestCaseWithWorkingTree):
+
+    def make_branch_with_merged_deletions(self, relpath='tree'):
+        tree = self.make_branch_and_tree(relpath)
+        files = ['a', 'b/', 'b/c']
+        self.build_tree(files, line_endings='binary',
+                        transport=tree.bzrdir.root_transport)
+        tree.set_root_id('root-id')
+        tree.add(files, ['a-id', 'b-id', 'c-id'])
+        tree.commit('a, b and b/c', rev_id='base')
+        tree2 = tree.bzrdir.sprout(relpath + '2').open_workingtree()
+        # Delete 'a' in tree
+        tree.remove('a', keep_files=False)
+        tree.commit('remove a', rev_id='this')
+        # Delete 'c' in tree2
+        tree2.remove('b/c', keep_files=False)
+        tree2.remove('b', keep_files=False)
+        tree2.commit('remove b/c', rev_id='other')
+        # Merge tree2 into tree
+        tree.merge_from_branch(tree2.branch)
+        return tree
+
+    def test_kind_parent_tree(self):
+        tree = self.make_branch_with_merged_deletions()
+        tree.lock_read()
+        self.addCleanup(tree.unlock)
+        parents = tree.get_parent_ids()
+        self.assertEqual(['this', 'other'], parents)
+        basis = tree.revision_tree(parents[0])
+        basis.lock_read()
+        self.addCleanup(basis.unlock)
+        self.assertRaises(errors.NoSuchId, basis.kind, 'a-id')
+        self.assertEqual(['directory', 'file'],
+                         [basis.kind('b-id'), basis.kind('c-id')])
+        try:
+            other = tree.revision_tree(parents[1])
+        except errors.NoSuchRevisionInTree:
+            raise tests.TestNotApplicable(
+                'Tree type %s caches only the basis revision tree.'
+                % type(tree))
+        other.lock_read()
+        self.addCleanup(other.unlock)
+        self.assertRaises(errors.NoSuchId, other.kind, 'b-id')
+        self.assertRaises(errors.NoSuchId, other.kind, 'c-id')
+        self.assertEqual('file', other.kind('a-id'))

=== modified file 'bzrlib/tests/per_workingtree/test_workingtree.py'
--- bzrlib/tests/per_workingtree/test_workingtree.py	2010-02-13 01:50:29 +0000
+++ bzrlib/tests/per_workingtree/test_workingtree.py	2010-03-02 22:25:58 +0000
@@ -423,7 +423,8 @@
         made_control = self.bzrdir_format.initialize('new')
         source.branch.repository.clone(made_control)
         source.branch.clone(made_control)
-        made_tree = self.workingtree_format.initialize(made_control, revision_id='a')
+        made_tree = self.workingtree_format.initialize(made_control,
+            revision_id='a')
         self.assertEqual(['a'], made_tree.get_parent_ids())
 
     def test_update_sets_last_revision(self):
@@ -447,7 +448,8 @@
         # current format
         self.build_tree(['checkout/', 'tree/file'])
         checkout = bzrdir.BzrDirMetaFormat1().initialize('checkout')
-        branch.BranchReferenceFormat().initialize(checkout, main_branch)
+        branch.BranchReferenceFormat().initialize(checkout,
+            target_branch=main_branch)
         old_tree = self.workingtree_format.initialize(checkout)
         # now commit to 'tree'
         wt.add('file')
@@ -514,7 +516,8 @@
         # current format
         self.build_tree(['checkout/', 'tree/file'])
         checkout = bzrdir.BzrDirMetaFormat1().initialize('checkout')
-        branch.BranchReferenceFormat().initialize(checkout, main_branch)
+        branch.BranchReferenceFormat().initialize(checkout,
+            target_branch=main_branch)
         old_tree = self.workingtree_format.initialize(checkout)
         # now commit to 'tree'
         wt.add('file')

=== modified file 'bzrlib/tests/test_branch.py'
--- bzrlib/tests/test_branch.py	2010-02-10 17:52:08 +0000
+++ bzrlib/tests/test_branch.py	2010-03-11 13:14:37 +0000
@@ -123,16 +123,16 @@
         """See BzrBranchFormat.get_format_string()."""
         return "Sample branch format."
 
-    def initialize(self, a_bzrdir):
+    def initialize(self, a_bzrdir, name=None):
         """Format 4 branches cannot be created."""
-        t = a_bzrdir.get_branch_transport(self)
+        t = a_bzrdir.get_branch_transport(self, name=name)
         t.put_bytes('format', self.get_format_string())
         return 'A branch'
 
     def is_supported(self):
         return False
 
-    def open(self, transport, _found=False, ignore_fallbacks=False):
+    def open(self, transport, name=None, _found=False, ignore_fallbacks=False):
         return "opened branch."
 
 
@@ -438,7 +438,7 @@
         t.mkdir('branch')
         branch_dir = bzrdirformat.initialize(self.get_url('branch'))
         made_branch = _mod_branch.BranchReferenceFormat().initialize(
-            branch_dir, target_branch)
+            branch_dir, target_branch=target_branch)
         self.assertEqual(made_branch.base, target_branch.base)
         opened_branch = branch_dir.open_branch()
         self.assertEqual(opened_branch.base, target_branch.base)

=== modified file 'bzrlib/tests/test_bzrdir.py'
--- bzrlib/tests/test_bzrdir.py	2010-03-02 19:50:18 +0000
+++ bzrlib/tests/test_bzrdir.py	2010-03-02 22:25:58 +0000
@@ -471,7 +471,8 @@
         # Make stackable source branch with an unstackable repo format.
         source_bzrdir = self.make_bzrdir('source')
         pack_repo.RepositoryFormatKnitPack1().initialize(source_bzrdir)
-        source_branch = bzrlib.branch.BzrBranchFormat7().initialize(source_bzrdir)
+        source_branch = bzrlib.branch.BzrBranchFormat7().initialize(
+            source_bzrdir)
         # Make a directory with a default stacking policy
         parent_bzrdir = self.make_bzrdir('parent')
         stacked_on = self.make_branch('parent/stacked-on', format='pack-0.92')

=== modified file 'bzrlib/tests/test_commands.py'
--- bzrlib/tests/test_commands.py	2010-03-01 09:27:39 +0000
+++ bzrlib/tests/test_commands.py	2010-03-25 09:39:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -211,14 +211,13 @@
         commands.Command.hooks.install_named_hook(
             "extend_command", hook_calls.append, None)
         # create a command, should not fire
-        class ACommand(commands.Command):
+        class cmd_test_extend_command_hook(commands.Command):
             """A sample command."""
-        cmd = ACommand()
         self.assertEqual([], hook_calls)
         # -- as a builtin
         # register the command class, should not fire
         try:
-            builtins.cmd_test_extend_command_hook = ACommand
+            commands.builtin_command_registry.register(cmd_test_extend_command_hook)
             self.assertEqual([], hook_calls)
             # and ask for the object, should fire
             cmd = commands.get_cmd_object('test-extend-command-hook')
@@ -228,7 +227,7 @@
             self.assertSubset([cmd], hook_calls)
             del hook_calls[:]
         finally:
-            del builtins.cmd_test_extend_command_hook
+            commands.builtin_command_registry.remove('test-extend-command-hook')
         # -- as a plugin lazy registration
         try:
             # register the command class, should not fire

=== modified file 'bzrlib/tests/test_export.py'
--- bzrlib/tests/test_export.py	2010-02-04 16:06:36 +0000
+++ bzrlib/tests/test_export.py	2010-03-08 02:23:17 +0000
@@ -20,7 +20,6 @@
 from bzrlib import (
     errors,
     export,
-    osutils,
     tests,
     )
 
@@ -99,3 +98,25 @@
         st_b = t.stat('b')
         # All files must be given the same mtime.
         self.assertEqual(st_a.st_mtime, st_b.st_mtime)
+
+    def test_dir_export_files_per_file_timestamps(self):
+        builder = self.make_branch_builder('source')
+        builder.start_series()
+        builder.build_snapshot(None, None, [
+            ('add', ('', 'root-id', 'directory', '')),
+            ('add', ('a', 'a-id', 'file', 'content\n'))],
+            timestamp=3423)
+        builder.build_snapshot(None, None, [
+            ('add', ('b', 'b-id', 'file', 'content\n'))],
+            timestamp=42)
+        builder.finish_series()
+        b = builder.get_branch()
+        b.lock_read()
+        self.addCleanup(b.unlock)
+        tree = b.basis_tree()
+        export.export(tree, 'target', format='dir', per_file_timestamps=True)
+        t = self.get_transport('target')
+        st_a = t.stat('a')
+        st_b = t.stat('b')
+        self.assertEqual(42.0, st_b.st_mtime)
+        self.assertEqual(3423.0, st_a.st_mtime)

=== modified file 'bzrlib/tests/test_foreign.py'
--- bzrlib/tests/test_foreign.py	2010-03-02 19:50:18 +0000
+++ bzrlib/tests/test_foreign.py	2010-03-02 22:25:58 +0000
@@ -171,11 +171,11 @@
         super(DummyForeignVcsBranchFormat, self).__init__()
         self._matchingbzrdir = DummyForeignVcsDirFormat()
 
-    def open(self, a_bzrdir, _found=False):
+    def open(self, a_bzrdir, name=None, _found=False):
         if not _found:
             raise NotImplementedError
         try:
-            transport = a_bzrdir.get_branch_transport(None)
+            transport = a_bzrdir.get_branch_transport(None, name=name)
             control_files = lockable_files.LockableFiles(transport, 'lock',
                                                          lockdir.LockDir)
             return DummyForeignVcsBranch(_format=self,

=== modified file 'bzrlib/tests/test_import_tariff.py'
--- bzrlib/tests/test_import_tariff.py	2010-02-10 02:17:15 +0000
+++ bzrlib/tests/test_import_tariff.py	2010-03-23 06:03:14 +0000
@@ -36,6 +36,14 @@
     """
 
     def run_command_check_imports(self, args, forbidden_imports):
+        """Run bzr ARGS in a subprocess and check its imports.
+
+        This is fairly expensive because we start a subprocess, so we aim to
+        cover representative rather than exhaustive cases.
+
+        :param forbidden_imports: List of fully-qualified Python module names
+            that should not be loaded while running this command.
+        """
         # We use PYTHON_VERBOSE rather than --profile-importts because in
         # experimentation the profile-imports output seems to not always show
         # the modules you'd expect; this can be debugged but python -v seems
@@ -82,6 +90,7 @@
         # 'st' in a working tree shouldn't need many modules
         self.make_branch_and_tree('.')
         self.run_command_check_imports(['st'], [
+            'bzrlib.bundle.commands',
             'bzrlib.remote',
             'bzrlib.smart',
             'smtplib',

=== modified file 'bzrlib/tests/test_osutils.py'
--- bzrlib/tests/test_osutils.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/test_osutils.py	2010-03-11 06:24:00 +0000
@@ -33,6 +33,7 @@
     win32utils,
     )
 from bzrlib.tests import (
+    features,
     file_utils,
     test__walkdirs_win32,
     )
@@ -1975,3 +1976,43 @@
         del os.environ['COLUMNS']
         # Whatever the result is, if we don't raise an exception, it's ok.
         osutils.terminal_width()
+
+class TestCreationOps(tests.TestCaseInTempDir):
+    _test_needs_features = [features.chown_feature]
+
+    def setUp(self):
+        tests.TestCaseInTempDir.setUp(self)
+        self.overrideAttr(os, 'chown', self._dummy_chown)
+
+        # params set by call to _dummy_chown
+        self.path = self.uid = self.gid = None
+
+    def _dummy_chown(self, path, uid, gid):
+        self.path, self.uid, self.gid = path, uid, gid
+
+    def test_mkdir_with_ownership_chown(self):
+        """Ensure that osutils.mkdir_with_ownership chowns correctly with ownership_src.
+        """
+        ownsrc = '/'
+        osutils.mkdir_with_ownership('foo', ownsrc)
+
+        s = os.stat(ownsrc)
+        self.assertEquals(self.path, 'foo')
+        self.assertEquals(self.uid, s.st_uid)
+        self.assertEquals(self.gid, s.st_gid)
+
+    def test_open_with_ownership_chown(self):
+        """Ensure that osutils.open_with_ownership chowns correctly with ownership_src.
+        """
+        ownsrc = '/'
+        f = osutils.open_with_ownership('foo', 'w', ownership_src=ownsrc)
+
+        # do a test write and close
+        f.write('hello')
+        f.close()
+
+        s = os.stat(ownsrc)
+        self.assertEquals(self.path, 'foo')
+        self.assertEquals(self.uid, s.st_uid)
+        self.assertEquals(self.gid, s.st_gid)
+

=== modified file 'bzrlib/tests/test_plugins.py'
--- bzrlib/tests/test_plugins.py	2010-01-25 17:48:22 +0000
+++ bzrlib/tests/test_plugins.py	2010-03-24 11:55:49 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2007 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,41 +20,75 @@
 # affects the global state of the process.  See bzrlib/plugins.py for more
 # comments.
 
+from cStringIO import StringIO
 import logging
 import os
-from StringIO import StringIO
 import sys
-import zipfile
 
+import bzrlib
 from bzrlib import (
     osutils,
     plugin,
+    plugins,
     tests,
-    )
-import bzrlib.plugin
-import bzrlib.plugins
-import bzrlib.commands
-import bzrlib.help
-from bzrlib.tests import (
-    TestCase,
-    TestCaseInTempDir,
-    TestUtil,
-    )
-from bzrlib.osutils import pathjoin, abspath, normpath
-
-
-PLUGIN_TEXT = """\
-import bzrlib.commands
-class cmd_myplug(bzrlib.commands.Command):
-    '''Just a simple test plugin.'''
-    aliases = ['mplg']
-    def run(self):
-        print 'Hello from my plugin'
-"""
+    trace,
+    )
+
 
 # TODO: Write a test for plugin decoration of commands.
 
-class TestLoadingPlugins(TestCaseInTempDir):
+class TestPluginMixin(object):
+
+    def create_plugin(self, name, source=None, dir='.', file_name=None):
+        if source is None:
+            source = '''\
+"""This is the doc for %s"""
+''' % (name)
+        if file_name is None:
+            file_name = name + '.py'
+        # 'source' must not fail to load
+        path = osutils.pathjoin(dir, file_name)
+        f = open(path, 'w')
+        self.addCleanup(os.unlink, path)
+        try:
+            f.write(source + '\n')
+        finally:
+            f.close()
+
+    def create_plugin_package(self, name, dir=None, source=None):
+        if dir is None:
+            dir = name
+        if source is None:
+            source = '''\
+"""This is the doc for %s"""
+dir_source = '%s'
+''' % (name, dir)
+        os.makedirs(dir)
+        def cleanup():
+            # Workaround lazy import random? madness
+            osutils.rmtree(dir)
+        self.addCleanup(cleanup)
+        self.create_plugin(name, source, dir,
+                           file_name='__init__.py')
+
+    def _unregister_plugin(self, name):
+        """Remove the plugin from sys.modules and the bzrlib namespace."""
+        py_name = 'bzrlib.plugins.%s' % name
+        if py_name in sys.modules:
+            del sys.modules[py_name]
+        if getattr(bzrlib.plugins, name, None) is not None:
+            delattr(bzrlib.plugins, name)
+
+    def assertPluginUnknown(self, name):
+        self.failIf(getattr(bzrlib.plugins, name, None) is not None)
+        self.failIf('bzrlib.plugins.%s' % name in sys.modules)
+
+    def assertPluginKnown(self, name):
+        self.failUnless(getattr(bzrlib.plugins, name, None) is not None)
+        self.failUnless('bzrlib.plugins.%s' % name in sys.modules)
+
+
+class TestLoadingPlugins(tests.TestCaseInTempDir, TestPluginMixin):
 
     activeattributes = {}
 
@@ -68,8 +102,7 @@
         # set a place for the plugins to record their loading, and at the same
         # time validate that the location the plugins should record to is
         # valid and correct.
-        bzrlib.tests.test_plugins.TestLoadingPlugins.activeattributes \
-            [tempattribute] = []
+        self.__class__.activeattributes [tempattribute] = []
         self.failUnless(tempattribute in self.activeattributes)
         # create two plugin directories
         os.mkdir('first')
@@ -99,13 +132,12 @@
         finally:
             # remove the plugin 'plugin'
             del self.activeattributes[tempattribute]
-            if 'bzrlib.plugins.plugin' in sys.modules:
-                del sys.modules['bzrlib.plugins.plugin']
-            if getattr(bzrlib.plugins, 'plugin', None):
-                del bzrlib.plugins.plugin
-        self.failIf(getattr(bzrlib.plugins, 'plugin', None))
+            self._unregister_plugin('plugin')
+        self.assertPluginUnknown('plugin')
 
     def test_plugins_from_different_dirs_can_demand_load(self):
+        self.failIf('bzrlib.plugins.pluginone' in sys.modules)
+        self.failIf('bzrlib.plugins.plugintwo' in sys.modules)
         # This test tests that having two plugins in different
         # directories with different names allows them both to be loaded, when
         # we do a direct import statement.
@@ -143,6 +175,8 @@
 
         oldpath = bzrlib.plugins.__path__
         try:
+            self.failIf('bzrlib.plugins.pluginone' in sys.modules)
+            self.failIf('bzrlib.plugins.plugintwo' in sys.modules)
             bzrlib.plugins.__path__ = ['first', 'second']
             exec "import bzrlib.plugins.pluginone"
             self.assertEqual(['first'], self.activeattributes[tempattribute])
@@ -152,18 +186,16 @@
         finally:
             # remove the plugin 'plugin'
             del self.activeattributes[tempattribute]
-            if getattr(bzrlib.plugins, 'pluginone', None):
-                del bzrlib.plugins.pluginone
-            if getattr(bzrlib.plugins, 'plugintwo', None):
-                del bzrlib.plugins.plugintwo
-        self.failIf(getattr(bzrlib.plugins, 'pluginone', None))
-        self.failIf(getattr(bzrlib.plugins, 'plugintwo', None))
+            self._unregister_plugin('pluginone')
+            self._unregister_plugin('plugintwo')
+        self.assertPluginUnknown('pluginone')
+        self.assertPluginUnknown('plugintwo')
 
     def test_plugins_can_load_from_directory_with_trailing_slash(self):
         # This test tests that a plugin can load from a directory when the
         # directory in the path has a trailing slash.
         # check the plugin is not loaded already
-        self.failIf(getattr(bzrlib.plugins, 'ts_plugin', None))
+        self.assertPluginUnknown('ts_plugin')
         tempattribute = "trailing-slash"
         self.failIf(tempattribute in self.activeattributes)
         # set a place for the plugin to record its loading, and at the same
@@ -190,11 +222,9 @@
             bzrlib.plugin.load_from_path(['plugin_test'+os.sep])
             self.assertEqual(['plugin'], self.activeattributes[tempattribute])
         finally:
-            # remove the plugin 'plugin'
             del self.activeattributes[tempattribute]
-            if getattr(bzrlib.plugins, 'ts_plugin', None):
-                del bzrlib.plugins.ts_plugin
-        self.failIf(getattr(bzrlib.plugins, 'ts_plugin', None))
+            self._unregister_plugin('ts_plugin')
+        self.assertPluginUnknown('ts_plugin')
 
     def load_and_capture(self, name):
         """Load plugins from '.' capturing the output.
@@ -251,105 +281,102 @@
             "it to 'bad_plugin_name_'\.")
 
 
-class TestPlugins(TestCaseInTempDir):
+class TestPlugins(tests.TestCaseInTempDir, TestPluginMixin):
 
     def setup_plugin(self, source=""):
         # This test tests a new plugin appears in bzrlib.plugin.plugins().
         # check the plugin is not loaded already
-        self.failIf(getattr(bzrlib.plugins, 'plugin', None))
+        self.assertPluginUnknown('plugin')
         # write a plugin that _cannot_ fail to load.
         file('plugin.py', 'w').write(source + '\n')
         self.addCleanup(self.teardown_plugin)
-        bzrlib.plugin.load_from_path(['.'])
+        plugin.load_from_path(['.'])
 
     def teardown_plugin(self):
-        # remove the plugin 'plugin'
-        if 'bzrlib.plugins.plugin' in sys.modules:
-            del sys.modules['bzrlib.plugins.plugin']
-        if getattr(bzrlib.plugins, 'plugin', None):
-            del bzrlib.plugins.plugin
-        self.failIf(getattr(bzrlib.plugins, 'plugin', None))
+        self._unregister_plugin('plugin')
+        self.assertPluginUnknown('plugin')
 
     def test_plugin_appears_in_plugins(self):
         self.setup_plugin()
-        self.failUnless('plugin' in bzrlib.plugin.plugins())
-        self.failUnless(getattr(bzrlib.plugins, 'plugin', None))
-        plugins = bzrlib.plugin.plugins()
-        plugin = plugins['plugin']
-        self.assertIsInstance(plugin, bzrlib.plugin.PlugIn)
-        self.assertEqual(bzrlib.plugins.plugin, plugin.module)
+        self.assertPluginKnown('plugin')
+        p = plugin.plugins()['plugin']
+        self.assertIsInstance(p, bzrlib.plugin.PlugIn)
+        self.assertEqual(p.module, plugins.plugin)
 
     def test_trivial_plugin_get_path(self):
         self.setup_plugin()
-        plugins = bzrlib.plugin.plugins()
-        plugin = plugins['plugin']
+        p = plugin.plugins()['plugin']
         plugin_path = self.test_dir + '/plugin.py'
-        self.assertIsSameRealPath(plugin_path, normpath(plugin.path()))
+        self.assertIsSameRealPath(plugin_path, osutils.normpath(p.path()))
 
     def test_plugin_get_path_py_not_pyc(self):
-        self.setup_plugin()         # after first import there will be plugin.pyc
+        # first import creates plugin.pyc
+        self.setup_plugin()
         self.teardown_plugin()
-        bzrlib.plugin.load_from_path(['.']) # import plugin.pyc
-        plugins = bzrlib.plugin.plugins()
-        plugin = plugins['plugin']
+        plugin.load_from_path(['.']) # import plugin.pyc
+        p = plugin.plugins()['plugin']
         plugin_path = self.test_dir + '/plugin.py'
-        self.assertIsSameRealPath(plugin_path, normpath(plugin.path()))
+        self.assertIsSameRealPath(plugin_path, osutils.normpath(p.path()))
 
     def test_plugin_get_path_pyc_only(self):
-        self.setup_plugin()         # after first import there will be plugin.pyc
+        # first import creates plugin.pyc (or plugin.pyo depending on __debug__)
+        self.setup_plugin()
         self.teardown_plugin()
         os.unlink(self.test_dir + '/plugin.py')
-        bzrlib.plugin.load_from_path(['.']) # import plugin.pyc
-        plugins = bzrlib.plugin.plugins()
-        plugin = plugins['plugin']
+        plugin.load_from_path(['.']) # import plugin.pyc (or .pyo)
+        p = plugin.plugins()['plugin']
         if __debug__:
             plugin_path = self.test_dir + '/plugin.pyc'
         else:
             plugin_path = self.test_dir + '/plugin.pyo'
-        self.assertIsSameRealPath(plugin_path, normpath(plugin.path()))
+        self.assertIsSameRealPath(plugin_path, osutils.normpath(p.path()))
 
     def test_no_test_suite_gives_None_for_test_suite(self):
         self.setup_plugin()
-        plugin = bzrlib.plugin.plugins()['plugin']
-        self.assertEqual(None, plugin.test_suite())
+        p = plugin.plugins()['plugin']
+        self.assertEqual(None, p.test_suite())
 
     def test_test_suite_gives_test_suite_result(self):
         source = """def test_suite(): return 'foo'"""
         self.setup_plugin(source)
-        plugin = bzrlib.plugin.plugins()['plugin']
-        self.assertEqual('foo', plugin.test_suite())
+        p = plugin.plugins()['plugin']
+        self.assertEqual('foo', p.test_suite())
 
     def test_no_load_plugin_tests_gives_None_for_load_plugin_tests(self):
         self.setup_plugin()
-        loader = TestUtil.TestLoader()
-        plugin = bzrlib.plugin.plugins()['plugin']
-        self.assertEqual(None, plugin.load_plugin_tests(loader))
+        loader = tests.TestUtil.TestLoader()
+        p = plugin.plugins()['plugin']
+        self.assertEqual(None, p.load_plugin_tests(loader))
 
     def test_load_plugin_tests_gives_load_plugin_tests_result(self):
         source = """
 def load_tests(standard_tests, module, loader):
     return 'foo'"""
         self.setup_plugin(source)
-        loader = TestUtil.TestLoader()
-        plugin = bzrlib.plugin.plugins()['plugin']
-        self.assertEqual('foo', plugin.load_plugin_tests(loader))
+        loader = tests.TestUtil.TestLoader()
+        p = plugin.plugins()['plugin']
+        self.assertEqual('foo', p.load_plugin_tests(loader))
+
+    def check_version_info(self, expected, source='', name='plugin'):
+        self.setup_plugin(source)
+        self.assertEqual(expected, plugin.plugins()[name].version_info())
 
     def test_no_version_info(self):
-        self.setup_plugin()
-        plugin = bzrlib.plugin.plugins()['plugin']
-        self.assertEqual(None, plugin.version_info())
+        self.check_version_info(None)
 
     def test_with_version_info(self):
-        self.setup_plugin("version_info = (1, 2, 3, 'dev', 4)")
-        plugin = bzrlib.plugin.plugins()['plugin']
-        self.assertEqual((1, 2, 3, 'dev', 4), plugin.version_info())
+        self.check_version_info((1, 2, 3, 'dev', 4),
+                                "version_info = (1, 2, 3, 'dev', 4)")
 
     def test_short_version_info_gets_padded(self):
         # the gtk plugin has version_info = (1,2,3) rather than the 5-tuple.
         # so we adapt it
-        self.setup_plugin("version_info = (1, 2, 3)")
-        plugin = bzrlib.plugin.plugins()['plugin']
-        self.assertEqual((1, 2, 3, 'final', 0), plugin.version_info())
+        self.check_version_info((1, 2, 3, 'final', 0),
+                                "version_info = (1, 2, 3)")
+
+    def check_version(self, expected, source=None, name='plugin'):
+        self.setup_plugin(source)
+        self.assertEqual(expected, plugins[name].__version__)
 
     def test_no_version_info___version__(self):
         self.setup_plugin()
@@ -407,7 +434,7 @@
         self.assertEqual("1.2.3.final.2", plugin.__version__)
 
 
-class TestPluginHelp(TestCaseInTempDir):
+class TestPluginHelp(tests.TestCaseInTempDir):
 
     def split_help_commands(self):
         help = {}
@@ -442,8 +469,17 @@
     def test_plugin_help_shows_plugin(self):
         # Create a test plugin
         os.mkdir('plugin_test')
-        f = open(pathjoin('plugin_test', 'myplug.py'), 'w')
-        f.write(PLUGIN_TEXT)
+        f = open(osutils.pathjoin('plugin_test', 'myplug.py'), 'w')
+        f.write("""\
+from bzrlib import commands
+class cmd_myplug(commands.Command):
+    '''Just a simple test plugin.'''
+    aliases = ['mplg']
+    def run(self):
+        print 'Hello from my plugin'
+
+"""
+)
         f.close()
 
         try:
@@ -627,7 +663,7 @@
         self.assertEqual(path, bzrlib.plugins.__path__)
 
 
-class TestEnvPluginPath(tests.TestCaseInTempDir):
+class TestEnvPluginPath(tests.TestCase):
 
     def setUp(self):
         super(TestEnvPluginPath, self).setUp()
@@ -680,13 +716,13 @@
         self.check_path([self.user, self.core, self.site],
                         ['+user', '+user'])
         # And only the first reference is kept (since the later references will
-        # onnly produce <plugin> already loaded mutters)
+        # only produce '<plugin> already loaded' mutters)
         self.check_path([self.user, self.core, self.site],
                         ['+user', '+user', '+core',
                          '+user', '+site', '+site',
                          '+core'])
 
-    def test_disable_overrides_disable(self):
+    def test_disable_overrides_enable(self):
         self.check_path([self.core, self.site], ['-user', '+user'])
 
     def test_disable_core(self):
@@ -719,3 +755,114 @@
     def test_bogus_references(self):
         self.check_path(['+foo', '-bar', self.core, self.site],
                         ['+foo', '-bar'])
+
+
+class TestDisablePlugin(tests.TestCaseInTempDir, TestPluginMixin):
+
+    def setUp(self):
+        super(TestDisablePlugin, self).setUp()
+        self.create_plugin_package('test_foo')
+        # Make sure we don't pollute the plugins namespace
+        self.overrideAttr(plugins, '__path__')
+        # Be paranoid in case a test fail
+        self.addCleanup(self._unregister_plugin, 'test_foo')
+
+    def test_cannot_import(self):
+        osutils.set_or_unset_env('BZR_DISABLE_PLUGINS', 'test_foo')
+        plugin.set_plugins_path(['.'])
+        try:
+            import bzrlib.plugins.test_foo
+        except ImportError:
+            pass
+        self.assertPluginUnknown('test_foo')
+
+    def test_regular_load(self):
+        self.overrideAttr(plugin, '_loaded', False)
+        plugin.load_plugins(['.'])
+        self.assertPluginKnown('test_foo')
+        self.assertEqual("This is the doc for test_foo",
+                         bzrlib.plugins.test_foo.__doc__)
+
+    def test_not_loaded(self):
+        self.warnings = []
+        def captured_warning(*args, **kwargs):
+            self.warnings.append((args, kwargs))
+        self.overrideAttr(trace, 'warning', captured_warning)
+        # Reset the flag that protect against double loading
+        self.overrideAttr(plugin, '_loaded', False)
+        osutils.set_or_unset_env('BZR_DISABLE_PLUGINS', 'test_foo')
+        plugin.load_plugins(['.'])
+        self.assertPluginUnknown('test_foo')
+        # Make sure we don't warn about the plugin ImportError since this has
+        # been *requested* by the user.
+        self.assertLength(0, self.warnings)
+
+
+class TestLoadPluginAt(tests.TestCaseInTempDir, TestPluginMixin):
+
+    def setUp(self):
+        super(TestLoadPluginAt, self).setUp()
+        # Make sure we don't pollute the plugins namespace
+        self.overrideAttr(plugins, '__path__')
+        # Be paranoid in case a test fail
+        self.addCleanup(self._unregister_plugin, 'test_foo')
+        # Reset the flag that protect against double loading
+        self.overrideAttr(plugin, '_loaded', False)
+        # Create the same plugin in two directories
+        self.create_plugin_package('test_foo', dir='non-standard-dir')
+        self.create_plugin_package('test_foo', dir='b/test_foo')
+
+    def assertTestFooLoadedFrom(self, dir):
+        self.assertPluginKnown('test_foo')
+        self.assertEqual('This is the doc for test_foo',
+                         bzrlib.plugins.test_foo.__doc__)
+        self.assertEqual(dir, bzrlib.plugins.test_foo.dir_source)
+
+    def test_regular_load(self):
+        plugin.load_plugins(['b'])
+        self.assertTestFooLoadedFrom('b/test_foo')
+
+    def test_import(self):
+        osutils.set_or_unset_env('BZR_PLUGINS_AT', 'test_foo@non-standard-dir')
+        plugin.set_plugins_path(['b'])
+        try:
+            import bzrlib.plugins.test_foo
+        except ImportError:
+            pass
+        self.assertTestFooLoadedFrom('non-standard-dir')
+
+    def test_loading(self):
+        osutils.set_or_unset_env('BZR_PLUGINS_AT', 'test_foo@non-standard-dir')
+        plugin.load_plugins(['b'])
+        self.assertTestFooLoadedFrom('non-standard-dir')
+
+    def test_compiled_loaded(self):
+        osutils.set_or_unset_env('BZR_PLUGINS_AT', 'test_foo@non-standard-dir')
+        plugin.load_plugins(['b'])
+        self.assertTestFooLoadedFrom('non-standard-dir')
+        self.assertEqual('non-standard-dir/__init__.py',
+                         bzrlib.plugins.test_foo.__file__)
+
+        # Try importing again now that the source has been compiled
+        self._unregister_plugin('test_foo')
+        plugin._loaded = False
+        plugin.load_plugins(['b'])
+        self.assertTestFooLoadedFrom('non-standard-dir')
+        if __debug__:
+            suffix = 'pyc'
+        else:
+            suffix = 'pyo'
+        self.assertEqual('non-standard-dir/__init__.%s' % suffix,
+                         bzrlib.plugins.test_foo.__file__)
+
+    def test_submodule_loading(self):
+        # We create an additional directory under the one for test_foo
+        self.create_plugin_package('test_bar', dir='non-standard-dir/test_bar')
+        osutils.set_or_unset_env('BZR_PLUGINS_AT', 'test_foo@non-standard-dir')
+        plugin.set_plugins_path(['b'])
+        import bzrlib.plugins.test_foo
+        self.assertEqual('bzrlib.plugins.test_foo',
+                         bzrlib.plugins.test_foo.__package__)
+        import bzrlib.plugins.test_foo.test_bar
+        self.assertEqual('non-standard-dir/test_bar/__init__.py',
+                         bzrlib.plugins.test_foo.test_bar.__file__)

=== modified file 'bzrlib/tests/test_smart.py'
--- bzrlib/tests/test_smart.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/test_smart.py	2010-03-02 22:25:58 +0000
@@ -214,7 +214,7 @@
         dir = self.make_bzrdir('.')
         local_result = dir.cloning_metadir()
         reference = _mod_branch.BranchReferenceFormat().initialize(
-            dir, referenced_branch)
+            dir, target_branch=referenced_branch)
         reference_url = _mod_branch.BranchReferenceFormat().get_reference(dir)
         # The server shouldn't try to follow the branch reference, so it's fine
         # if the referenced branch isn't reachable.

=== modified file 'bzrlib/tests/test_tag.py'
--- bzrlib/tests/test_tag.py	2009-05-06 05:36:28 +0000
+++ bzrlib/tests/test_tag.py	2010-03-25 09:39:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,16 +14,15 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+"""Tests for bzrlib.tag."""
+
 
 from bzrlib import (
-    branch,
     bzrdir,
     errors,
-    tag,
     )
 from bzrlib.tag import (
     BasicTags,
-    _merge_tags_if_possible,
     DisabledTags,
     )
 from bzrlib.tests import (
@@ -184,3 +183,6 @@
 
     def test_get_reverse_tag_dict(self):
         self.assertEqual(self.tags.get_reverse_tag_dict(), {})
+
+
+

=== modified file 'bzrlib/trace.py'
--- bzrlib/trace.py	2010-03-10 13:25:36 +0000
+++ bzrlib/trace.py	2010-03-25 09:39:03 +0000
@@ -241,14 +241,17 @@
     _bzr_log_filename = _get_bzr_log_filename()
     _rollover_trace_maybe(_bzr_log_filename)
     try:
-        bzr_log_file = open(_bzr_log_filename, 'at', buffering=0) # unbuffered
+        buffering = 0 # unbuffered
+        bzr_log_file = osutils.open_with_ownership(_bzr_log_filename, 'at', buffering)
         # bzr_log_file.tell() on windows always return 0 until some writing done
         bzr_log_file.write('\n')
         if bzr_log_file.tell() <= 2:
             bzr_log_file.write("this is a debug log for diagnosing/reporting problems in bzr\n")
             bzr_log_file.write("you can delete or truncate this file, or include sections in\n")
             bzr_log_file.write("bug reports to https://bugs.launchpad.net/bzr/+filebug\n\n")
+
         return bzr_log_file
+
     except IOError, e:
         # If we are failing to open the log, then most likely logging has not
         # been set up yet. So we just write to stderr rather than using

=== modified file 'bzrlib/transport/__init__.py'
--- bzrlib/transport/__init__.py	2010-02-23 07:43:11 +0000
+++ bzrlib/transport/__init__.py	2010-03-17 05:36:11 +0000
@@ -1060,7 +1060,12 @@
         """
         source = self.clone(from_relpath)
         target = self.clone(to_relpath)
-        target.mkdir('.')
+
+        # create target directory with the same rwx bits as source.
+        # use mask to ensure that bits other than rwx are ignored.
+        stat = self.stat(from_relpath)
+        target.mkdir('.', stat.st_mode & 0777)
+
         source.copy_tree_to_transport(target)
 
     def copy_tree_to_transport(self, to_transport):
@@ -1202,6 +1207,18 @@
         count = self._iterate_over(relpaths, gather, pb, 'stat', expand=False)
         return stats
 
+    def readlink(self, relpath):
+        """Return a string representing the path to which the symbolic link points."""
+        raise errors.TransportNotPossible("Dereferencing symlinks is not supported on %s" % self)
+
+    def hardlink(self, source, link_name):
+        """Create a hardlink pointing to source named link_name."""
+        raise errors.TransportNotPossible("Hard links are not supported on %s" % self)
+
+    def symlink(self, source, link_name):
+        """Create a symlink pointing to source named link_name."""
+        raise errors.TransportNotPossible("Symlinks are not supported on %s" % self)
+
     def listable(self):
         """Return True if this store supports listing."""
         raise NotImplementedError(self.listable)
@@ -1831,6 +1848,6 @@
 
 
 transport_server_registry = registry.Registry()
-transport_server_registry.register_lazy('bzr', 'bzrlib.smart.server', 
+transport_server_registry.register_lazy('bzr', 'bzrlib.smart.server',
     'serve_bzr', help="The Bazaar smart server protocol over TCP. (default port: 4155)")
 transport_server_registry.default_key = 'bzr'

=== modified file 'bzrlib/transport/local.py'
--- bzrlib/transport/local.py	2010-03-05 08:55:12 +0000
+++ bzrlib/transport/local.py	2010-03-11 04:18:33 +0000
@@ -481,7 +481,7 @@
         path = relpath
         try:
             path = self._abspath(relpath)
-            return os.stat(path)
+            return os.lstat(path)
         except (IOError, OSError),e:
             self._translate_error(e, path)
 
@@ -515,6 +515,33 @@
         except (IOError, OSError),e:
             self._translate_error(e, path)
 
+    if osutils.host_os_dereferences_symlinks():
+        def readlink(self, relpath):
+            """See Transport.readlink."""
+            return osutils.readlink(self._abspath(relpath))
+
+    if osutils.hardlinks_good():
+        def hardlink(self, source, link_name):
+            """See Transport.link."""
+            try:
+                os.link(self._abspath(source), self._abspath(link_name))
+            except (IOError, OSError), e:
+                self._translate_error(e, source)
+
+    if osutils.has_symlinks():
+        def symlink(self, source, link_name):
+            """See Transport.symlink."""
+            abs_link_dirpath = urlutils.dirname(self.abspath(link_name))
+            source_rel = urlutils.file_relpath(
+                urlutils.strip_trailing_slash(abs_link_dirpath),
+                urlutils.strip_trailing_slash(self.abspath(source))
+            )
+
+            try:
+                os.symlink(source_rel, self._abspath(link_name))
+            except (IOError, OSError), e:
+                self._translate_error(e, source_rel)
+
     def _can_roundtrip_unix_modebits(self):
         if sys.platform == 'win32':
             # anyone else?

=== modified file 'bzrlib/transport/sftp.py'
--- bzrlib/transport/sftp.py	2010-02-23 07:43:11 +0000
+++ bzrlib/transport/sftp.py	2010-03-04 02:43:41 +0000
@@ -82,7 +82,7 @@
 else:
     from paramiko.sftp import (SFTP_FLAG_WRITE, SFTP_FLAG_CREATE,
                                SFTP_FLAG_EXCL, SFTP_FLAG_TRUNC,
-                               CMD_HANDLE, CMD_OPEN)
+                               SFTP_OK, CMD_HANDLE, CMD_OPEN)
     from paramiko.sftp_attr import SFTPAttributes
     from paramiko.sftp_file import SFTPFile
 
@@ -810,10 +810,32 @@
         """Return the stat information for a file."""
         path = self._remote_path(relpath)
         try:
-            return self._get_sftp().stat(path)
+            return self._get_sftp().lstat(path)
         except (IOError, paramiko.SSHException), e:
             self._translate_io_exception(e, path, ': unable to stat')
 
+    def readlink(self, relpath):
+        """See Transport.readlink."""
+        path = self._remote_path(relpath)
+        try:
+            return self._get_sftp().readlink(path)
+        except (IOError, paramiko.SSHException), e:
+            self._translate_io_exception(e, path, ': unable to readlink')
+
+    def symlink(self, source, link_name):
+        """See Transport.symlink."""
+        try:
+            conn = self._get_sftp()
+            sftp_retval = conn.symlink(source, link_name)
+            if SFTP_OK != sftp_retval:
+                raise TransportError(
+                    '%r: unable to create symlink to %r' % (link_name, source),
+                    sftp_retval
+                )
+        except (IOError, paramiko.SSHException), e:
+            self._translate_io_exception(e, link_name,
+                                         ': unable to create symlink to %r' % (source))
+
     def lock_read(self, relpath):
         """
         Lock the given file for shared (read) access.

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2010-02-10 15:46:03 +0000
+++ bzrlib/workingtree.py	2010-03-02 22:25:58 +0000
@@ -1094,7 +1094,8 @@
         tree_transport = self.bzrdir.root_transport.clone(sub_path)
         if tree_transport.base != branch_transport.base:
             tree_bzrdir = format.initialize_on_transport(tree_transport)
-            branch.BranchReferenceFormat().initialize(tree_bzrdir, new_branch)
+            branch.BranchReferenceFormat().initialize(tree_bzrdir,
+                target_branch=new_branch)
         else:
             tree_bzrdir = branch_bzrdir
         wt = tree_bzrdir.create_workingtree(_mod_revision.NULL_REVISION)

=== modified file 'bzrlib/workingtree_4.py'
--- bzrlib/workingtree_4.py	2010-02-17 17:11:16 +0000
+++ bzrlib/workingtree_4.py	2010-03-10 09:31:25 +0000
@@ -1372,6 +1372,7 @@
 
 
 class DirStateWorkingTreeFormat(WorkingTreeFormat3):
+
     def initialize(self, a_bzrdir, revision_id=None, from_branch=None,
                    accelerator_tree=None, hardlink=False):
         """See WorkingTreeFormat.initialize().
@@ -1832,7 +1833,8 @@
         entry = self._get_entry(file_id=file_id)[1]
         if entry is None:
             raise errors.NoSuchId(tree=self, file_id=file_id)
-        return dirstate.DirState._minikind_to_kind[entry[1][0]]
+        parent_index = self._get_parent_index()
+        return dirstate.DirState._minikind_to_kind[entry[parent_index][0]]
 
     def stored_kind(self, file_id):
         """See Tree.stored_kind"""

=== modified file 'doc/developers/releasing.txt'
--- doc/developers/releasing.txt	2009-12-02 20:34:07 +0000
+++ doc/developers/releasing.txt	2010-03-17 02:58:08 +0000
@@ -55,6 +55,10 @@
    ``bzrlib/__init__.py`` file. Make sure there is always a corresponding
    milestone when you change that version number.
 
+#. Add a new section at the top of ``NEWS`` about the new release,
+   including its version number and the headings from
+   ``NEWS-template.txt``.
+
 #. Send mail to the list with the key dates, who will be the release
    manager, and the main themes or targeted bugs.  Ask people to nominate
    objectives, or point out any high-risk things that are best done early,

=== modified file 'doc/developers/testing.txt'
--- doc/developers/testing.txt	2010-02-28 10:08:29 +0000
+++ doc/developers/testing.txt	2010-03-18 06:25:23 +0000
@@ -455,6 +455,29 @@
   unless there is a good reason
 
 
+Testing locking behaviour
+-------------------------
+
+You may want to write tests that particular objects are or aren't locked
+during particular operations: see for example `bug 498409`__.  
+
+ __ https://launchpad.net/bugs/498409
+
+The `TestCase` base class registers hooks that record lock actions into 
+``._lock_actions`` in this format::
+
+  [
+    ('acquired', LockResult(file:///tmp/testbzr-J2pcy2.tmp/.bzr/branch-lockc4au55ppz8wdym11z1aq)),
+    ('released', LockResult(file:///tmp/testbzr-J2pcy2.tmp/.bzr/branch-lockc4au55ppz8wdym11z1aq)),
+    ('acquired', LockResult(file:///tmp/testbzr-J2pcy2.tmp/.bzr/repository/lockyxb3rn4sw1oyx1jzkt45)),
+    ('released', LockResult(file:///tmp/testbzr-J2pcy2.tmp/.bzr/repository/lockyxb3rn4sw1oyx1jzkt45)),
+    ('acquired', LockResult(file:///tmp/testbzr-J2pcy2.tmp/.bzr/branch/lockh8c6t28rcjdkgxtndbje)),
+    ('released', LockResult(file:///tmp/testbzr-J2pcy2.tmp/.bzr/branch/lockh8c6t28rcjdkgxtndbje)),
+    ...
+
+Alternatively you can register your own hooks to make custom assertions:
+see `TestCase._check_locks` for an example.
+
 Skipping tests
 --------------
 
@@ -576,6 +599,10 @@
  - UnicodeFilenameFeature
  - FTPServerFeature
  - CaseInsensitiveFilesystemFeature.
+ - chown_feature: The test can rely on OS being POSIX and python
+   supporting os.chown.
+ - posix_permissions_feature: The test can use POSIX-style
+   user/group/other permission bits.
 
 
 Defining a new feature that tests can require

=== modified file 'doc/en/_templates/index.html'
--- doc/en/_templates/index.html	2010-03-02 10:21:39 +0000
+++ doc/en/_templates/index.html	2010-03-04 04:15:18 +0000
@@ -7,7 +7,7 @@
 
   <table class="contentstable" align="center" style="margin-left: 30px"><tr>
     <td width="50%">
-        <p class="biglink"><a class="biglink" href="{{ pathto("whats-new/whats-new-in-2.1") }}">What's New in Bazaar 2.1?</a><br/>
+        <p class="biglink"><a class="biglink" href="{{ pathto("whats-new/whats-new-in-2.2") }}">What's New in Bazaar 2.2?</a><br/>
         <span class="linkdescr">what's new in this release</span>
       </p>
         <p class="biglink"><a class="biglink" href="{{ pathto("user-guide/index") }}">User Guide</a><br/>

=== modified file 'doc/en/index.txt'
--- doc/en/index.txt	2010-02-19 03:02:07 +0000
+++ doc/en/index.txt	2010-03-04 04:15:18 +0000
@@ -10,7 +10,7 @@
 .. toctree::
    :maxdepth: 1
 
-   whats-new/whats-new-in-2.1
+   whats-new/whats-new-in-2.2
    user-guide/index
    tutorials/index
    quick-reference/index

=== modified file 'doc/en/user-guide/branching_a_project.txt'
--- doc/en/user-guide/branching_a_project.txt	2009-12-02 20:34:07 +0000
+++ doc/en/user-guide/branching_a_project.txt	2010-03-22 00:29:50 +0000
@@ -30,6 +30,17 @@
 `URL Identifiers <../user-reference/bzr_man.html#url-identifiers>`_
 section of the Bazaar User Reference.
 
+URLs are normally resolved relative to the root directory of the server,
+so ``ftp://example.com/repo/foo`` means the ``/repo/foo`` directory of
+that host.  (We say 'normally' because some server software like Apache
+can be configured to remap URLs arbitrarily, in which case you'll need to
+look at the server configuration to find out which URL corresponds to
+which directory.)
+
+To address a path relative to your home directory on the server, use a
+tilde like so: ``sftp://example.com/~/public_html`` should map to
+``public_html`` within your home directory.
+
 A reminder about shared repositories
 ------------------------------------
 

=== modified file 'doc/en/user-guide/stacked.txt'
--- doc/en/user-guide/stacked.txt	2009-12-02 20:34:07 +0000
+++ doc/en/user-guide/stacked.txt	2010-03-18 08:03:39 +0000
@@ -1,15 +1,28 @@
 Using stacked branches
 ======================
 
+Motivation
+----------
+
+If you are working on a project, and you have read access to whose
+public repository but do not have write access to it, using stacked
+branches to backup/publish your work onto the same host of the public
+repository might be an option for you.
+
+Other scenarios for stacked branch usage include experimental branches
+and code hosting sites. For these scenarios, stacked branches are
+ideal because of the benefits it provides.
+
+
 What is a stacked branch?
 -------------------------
 
-A stacked branch is a branch that knows how to find revisions
-in another branch. Stacked branches store just the
-unique revisions, making them faster to create and more
-storage efficient. In these respects, stacked branches are
-similar to shared repositories. However, stacked branches have
-additional benefits:
+A stacked branch is a branch that knows how to find revisions in
+another branch (the stacked-on branch). Stacked branches store just
+the unique revisions that are not in the stacked-on branch, making
+them faster to create and more storage efficient. In these respects,
+stacked branches are similar to shared repositories. However, stacked
+branches have additional benefits:
 
 * The new branch can be in a completely different location to the
   branch being stacked on.
@@ -21,9 +34,6 @@
   repository can be physically readonly to developers committing to stacked
   branches.
 
-These benefits make stacked branches ideal for various scenarios
-including experimental branches and code hosting sites.
-
 
 Creating a stacked branch
 -------------------------
@@ -63,7 +73,14 @@
 
 This creates a new branch at ``my-url`` that is stacked on ``reference-url``
 and only contains the revisions in the current branch that are not already
-in the branch at ``reference-url``.
+in the branch at ``reference-url``. In particular, ``my-url`` and
+``reference-url`` can be on the same host, and the ``--stacked`` option
+can be used additionally to inform ``push`` to reference the
+revisions in ``reference-url``. For example::
+
+  bzr push --stacked-on sftp://host/project --stacked sftp://host/user/stacked-branch
+
+This usage fits the scenario described in the Motivation section.
 
 If the local branch was created as a stacked branch, then you can
 use the ``--stacked`` option to ``push`` and the *stacked-on* location

=== added file 'doc/en/whats-new/whats-new-in-2.2.txt'
--- doc/en/whats-new/whats-new-in-2.2.txt	1970-01-01 00:00:00 +0000
+++ doc/en/whats-new/whats-new-in-2.2.txt	2010-03-04 04:15:18 +0000
@@ -0,0 +1,70 @@
+What's New in Bazaar 2.2?
+=========================
+
+This document outlines the major improvements in Bazaar 2.2
+vs Bazaar 2.1. As well as summarizing improvements made to
+the core product, it highlights enhancements within the broader
+Bazaar world of potential interest to those upgrading.
+
+.. warning::
+
+   Bazaar 2.2.0 is currently in development. While less stable than
+   Bazaar 2.1.x, we aim to keep quality at a high level:
+
+   * Monthly beta releases should be suitable for early adopters of new
+     features.
+
+   * Nightly builds are suitable for users interested in assisting
+     with testing.
+
+   If it doubt, please use the latest 2.1 release instead.
+
+
+Improved conflict handling
+--------------------------
+
+Tree-shape conflicts can be resolved by providing ``--take-this`` and
+``--take-other`` to the ``bzr resolve`` command. Just marking the conflict
+as resolved is still accessible via the ``--done`` default action.
+
+
+Improved Launchpad integration
+------------------------------
+
+Merges can be proposed on Launchpad with the new **lp-propose-merge**
+command.
+
+
+Notable plugin enhancements
+---------------------------
+
+The grep plugin ...
+
+
+Better documentation
+--------------------
+
+Numerous improvements have been made to the developer documentation.
+
+
+Enhanced GUI clients
+--------------------
+
+(Details coming soon.)
+
+
+Further information
+-------------------
+
+For more detailed information on the changes made, be sure to check
+the :doc:`../release-notes/index` for:
+
+* the interim bzr `milestones <https://launchpad.net/bzr/2.2>`_
+* the plugins you use.
+
+For a summary of changes made in earlier releases, see:
+
+* :doc:`whats-new-in-2.1`
+
+Enjoy,
+The Bazaar Development Team

=== modified file 'setup.py'
--- setup.py	2010-03-05 08:55:12 +0000
+++ setup.py	2010-03-25 07:30:30 +0000
@@ -37,7 +37,7 @@
     'version':      bzrlib.__version__,
     'author':       'Canonical Ltd',
     'author_email': 'bazaar@lists.canonical.com',
-    'url':          'http://www.bazaar.canonical.com/',
+    'url':          'http://bazaar.canonical.com/',
     'description':  'Friendly distributed version control system',
     'license':      'GNU GPL v2',
     'download_url': 'https://launchpad.net/bzr/+download',
@@ -553,7 +553,7 @@
                                      version = version_str,
                                      description = META_INFO['description'],
                                      author = META_INFO['author'],
-                                     copyright = "(c) Canonical Ltd, 2005-2009",
+                                     copyright = "(c) Canonical Ltd, 2005-2010",
                                      company_name = "Canonical Ltd.",
                                      comments = META_INFO['description'],
                                     )
@@ -572,7 +572,7 @@
     if sys.version.startswith('2.4'):
         # adding elementtree package
         additional_packages.add('elementtree')
-    elif sys.version.startswith('2.5'):
+    elif sys.version.startswith('2.6') or sys.version.startswith('2.5'):
         additional_packages.add('xml.etree')
     else:
         import warnings
@@ -624,7 +624,11 @@
             excludes.extend(["bzrlib.plugins." + d for d in dirs])
         x = []
         for i in files:
-            if os.path.splitext(i)[1] not in [".py", ".pyd", ".dll", ".mo"]:
+            # Throw away files we don't want packaged. Note that plugins may
+            # have data files with all sorts of extensions so we need to
+            # be conservative here about what we ditch.
+            ext = os.path.splitext(i)[1]
+            if ext.endswith('~') or ext in [".pyc", ".swp"]:
                 continue
             if i == '__init__.py' and root == 'bzrlib/plugins':
                 continue

